{-# OPTIONS -fno-warn-name-shadowing -fno-warn-missing-signatures -fno-warn-unused-binds -fno-warn-unused-matches -fno-warn-incomplete-patterns    #-}
-- ^ grr. happy needs them all on one line

module Parser 
    ( parseProgram, parseExpr, parseType, parseConstraint, parseConstraintG ) 
where

import Control.Monad.State

import AST
import Lexer
import ParserUtils
import Logging
import Builtins

-- parser produced by Happy Version 1.17

data HappyAbsSyn t8 t9 t10 t11 t12 t19 t23 t24 t26 t27 t28 t33 t36 t41 t43 t47 t49 t55 t59 t65 t66 t69 t70 t76 t77 t78 t79 t80 t82 t86
	= HappyTerminal Token
	| HappyErrorToken Int
	| HappyAbsSyn8 t8
	| HappyAbsSyn9 t9
	| HappyAbsSyn10 t10
	| HappyAbsSyn11 t11
	| HappyAbsSyn12 t12
	| HappyAbsSyn13 (Program)
	| HappyAbsSyn14 ([Def])
	| HappyAbsSyn15 (Def)
	| HappyAbsSyn16 (Implementation)
	| HappyAbsSyn17 ([TyvarName])
	| HappyAbsSyn18 ([ReceiverDef])
	| HappyAbsSyn19 t19
	| HappyAbsSyn20 (ReceiverDef)
	| HappyAbsSyn21 (Interface)
	| HappyAbsSyn22 (([TyvarName], [ConR]))
	| HappyAbsSyn23 t23
	| HappyAbsSyn24 t24
	| HappyAbsSyn25 (Maybe [ReceiverSig])
	| HappyAbsSyn26 t26
	| HappyAbsSyn27 t27
	| HappyAbsSyn28 t28
	| HappyAbsSyn29 (Class)
	| HappyAbsSyn30 ((String, [TyvarName]))
	| HappyAbsSyn31 (TyN)
	| HappyAbsSyn32 ([MethodSig])
	| HappyAbsSyn33 t33
	| HappyAbsSyn36 t36
	| HappyAbsSyn37 (MethodSig)
	| HappyAbsSyn40 ([MethodDef])
	| HappyAbsSyn41 t41
	| HappyAbsSyn42 ([Either FieldDef (Either Constructor MethodDef)])
	| HappyAbsSyn43 t43
	| HappyAbsSyn44 (MethodDef)
	| HappyAbsSyn45 (Either FieldDef (Either Constructor MethodDef))
	| HappyAbsSyn47 t47
	| HappyAbsSyn49 t49
	| HappyAbsSyn52 (Maybe Type)
	| HappyAbsSyn53 ((VarName, [MethodArg]))
	| HappyAbsSyn54 ([(Type, String)])
	| HappyAbsSyn55 t55
	| HappyAbsSyn56 (Stmt)
	| HappyAbsSyn57 ([Stmt])
	| HappyAbsSyn59 t59
	| HappyAbsSyn60 (Expr)
	| HappyAbsSyn61 (Type)
	| HappyAbsSyn62 ((Posn, Type))
	| HappyAbsSyn63 (TyNK)
	| HappyAbsSyn64 ([ConP])
	| HappyAbsSyn65 t65
	| HappyAbsSyn66 t66
	| HappyAbsSyn67 (ConP)
	| HappyAbsSyn68 ([ConR])
	| HappyAbsSyn69 t69
	| HappyAbsSyn70 t70
	| HappyAbsSyn71 (ConR)
	| HappyAbsSyn72 ([TyG])
	| HappyAbsSyn73 (ConGP)
	| HappyAbsSyn74 ([Type])
	| HappyAbsSyn75 ([Expr])
	| HappyAbsSyn76 t76
	| HappyAbsSyn77 t77
	| HappyAbsSyn78 t78
	| HappyAbsSyn79 t79
	| HappyAbsSyn80 t80
	| HappyAbsSyn81 ([String])
	| HappyAbsSyn82 t82
	| HappyAbsSyn83 ((String, [Type]))
	| HappyAbsSyn84 (TyvarName)
	| HappyAbsSyn85 ([TyNK])
	| HappyAbsSyn86 t86

action_0 (8) = happyGoto action_45
action_0 (13) = happyGoto action_6
action_0 (14) = happyGoto action_7
action_0 _ = happyReduce_11

action_1 (87) = happyShift action_34
action_1 (109) = happyShift action_35
action_1 (113) = happyShift action_36
action_1 (114) = happyShift action_37
action_1 (115) = happyShift action_38
action_1 (116) = happyShift action_25
action_1 (117) = happyShift action_26
action_1 (119) = happyShift action_39
action_1 (125) = happyShift action_40
action_1 (132) = happyShift action_41
action_1 (133) = happyShift action_42
action_1 (134) = happyShift action_43
action_1 (135) = happyShift action_44
action_1 (9) = happyGoto action_29
action_1 (60) = happyGoto action_30
action_1 (62) = happyGoto action_31
action_1 (63) = happyGoto action_32
action_1 (83) = happyGoto action_33
action_1 _ = happyFail

action_2 (91) = happyShift action_24
action_2 (116) = happyShift action_25
action_2 (117) = happyShift action_26
action_2 (134) = happyShift action_27
action_2 (135) = happyShift action_28
action_2 (10) = happyGoto action_19
action_2 (62) = happyGoto action_20
action_2 (67) = happyGoto action_21
action_2 (72) = happyGoto action_22
action_2 (84) = happyGoto action_23
action_2 _ = happyFail

action_3 (91) = happyShift action_18
action_3 (116) = happyShift action_10
action_3 (117) = happyShift action_11
action_3 (134) = happyShift action_12
action_3 (135) = happyShift action_13
action_3 (11) = happyGoto action_14
action_3 (61) = happyGoto action_15
action_3 (73) = happyGoto action_16
action_3 (74) = happyGoto action_17
action_3 _ = happyFail

action_4 (116) = happyShift action_10
action_4 (117) = happyShift action_11
action_4 (134) = happyShift action_12
action_4 (135) = happyShift action_13
action_4 (12) = happyGoto action_8
action_4 (61) = happyGoto action_9
action_4 _ = happyFail

action_5 (13) = happyGoto action_6
action_5 (14) = happyGoto action_7
action_5 _ = happyFail

action_6 (136) = happyShift action_95
action_6 _ = happyFail

action_7 (97) = happyShift action_91
action_7 (98) = happyShift action_92
action_7 (99) = happyShift action_93
action_7 (100) = happyShift action_94
action_7 (15) = happyGoto action_86
action_7 (16) = happyGoto action_87
action_7 (17) = happyGoto action_88
action_7 (21) = happyGoto action_89
action_7 (29) = happyGoto action_90
action_7 _ = happyReduce_10

action_8 (137) = happyAccept
action_8 _ = happyFail

action_9 (136) = happyShift action_85
action_9 _ = happyFail

action_10 _ = happyReduce_122

action_11 _ = happyReduce_123

action_12 _ = happyReduce_120

action_13 (116) = happyShift action_10
action_13 (117) = happyShift action_11
action_13 (134) = happyShift action_12
action_13 (135) = happyShift action_13
action_13 (61) = happyGoto action_46
action_13 (78) = happyGoto action_84
action_13 (79) = happyGoto action_48
action_13 (80) = happyGoto action_49
action_13 _ = happyFail

action_14 (137) = happyAccept
action_14 _ = happyFail

action_15 (101) = happyShift action_82
action_15 (103) = happyShift action_83
action_15 _ = happyReduce_148

action_16 (136) = happyShift action_81
action_16 _ = happyFail

action_17 (102) = happyShift action_80
action_17 _ = happyFail

action_18 (116) = happyShift action_10
action_18 (117) = happyShift action_11
action_18 (134) = happyShift action_12
action_18 (135) = happyShift action_13
action_18 (61) = happyGoto action_46
action_18 (79) = happyGoto action_79
action_18 (80) = happyGoto action_49
action_18 _ = happyFail

action_19 (137) = happyAccept
action_19 _ = happyFail

action_20 _ = happyReduce_143

action_21 (136) = happyShift action_78
action_21 _ = happyFail

action_22 (102) = happyShift action_77
action_22 _ = happyFail

action_23 (101) = happyShift action_75
action_23 (103) = happyShift action_76
action_23 _ = happyFail

action_24 (116) = happyShift action_10
action_24 (117) = happyShift action_11
action_24 (134) = happyShift action_12
action_24 (135) = happyShift action_13
action_24 (61) = happyGoto action_46
action_24 (79) = happyGoto action_74
action_24 (80) = happyGoto action_49
action_24 _ = happyFail

action_25 _ = happyReduce_126

action_26 _ = happyReduce_127

action_27 (102) = happyReduce_124
action_27 _ = happyReduce_164

action_28 (116) = happyShift action_10
action_28 (117) = happyShift action_11
action_28 (134) = happyShift action_12
action_28 (135) = happyShift action_13
action_28 (61) = happyGoto action_46
action_28 (78) = happyGoto action_73
action_28 (79) = happyGoto action_48
action_28 (80) = happyGoto action_49
action_28 _ = happyFail

action_29 (137) = happyAccept
action_29 _ = happyFail

action_30 (95) = happyShift action_58
action_30 (118) = happyShift action_59
action_30 (119) = happyShift action_60
action_30 (120) = happyShift action_61
action_30 (121) = happyShift action_62
action_30 (122) = happyShift action_63
action_30 (123) = happyShift action_64
action_30 (124) = happyShift action_65
action_30 (126) = happyShift action_66
action_30 (127) = happyShift action_67
action_30 (128) = happyShift action_68
action_30 (129) = happyShift action_69
action_30 (130) = happyShift action_70
action_30 (131) = happyShift action_71
action_30 (136) = happyShift action_72
action_30 _ = happyFail

action_31 _ = happyReduce_128

action_32 (91) = happyShift action_57
action_32 _ = happyFail

action_33 (87) = happyShift action_56
action_33 (75) = happyGoto action_55
action_33 _ = happyFail

action_34 (116) = happyShift action_25
action_34 (117) = happyShift action_26
action_34 (134) = happyShift action_53
action_34 (135) = happyShift action_28
action_34 (62) = happyGoto action_31
action_34 (63) = happyGoto action_54
action_34 _ = happyFail

action_35 (116) = happyShift action_25
action_35 (117) = happyShift action_26
action_35 (134) = happyShift action_53
action_35 (135) = happyShift action_28
action_35 (62) = happyGoto action_31
action_35 (63) = happyGoto action_52
action_35 _ = happyFail

action_36 _ = happyReduce_97

action_37 _ = happyReduce_98

action_38 _ = happyReduce_96

action_39 (87) = happyShift action_34
action_39 (109) = happyShift action_35
action_39 (113) = happyShift action_36
action_39 (114) = happyShift action_37
action_39 (115) = happyShift action_38
action_39 (116) = happyShift action_25
action_39 (117) = happyShift action_26
action_39 (119) = happyShift action_39
action_39 (125) = happyShift action_40
action_39 (132) = happyShift action_41
action_39 (133) = happyShift action_42
action_39 (134) = happyShift action_43
action_39 (135) = happyShift action_44
action_39 (60) = happyGoto action_51
action_39 (62) = happyGoto action_31
action_39 (63) = happyGoto action_32
action_39 (83) = happyGoto action_33
action_39 _ = happyFail

action_40 (87) = happyShift action_34
action_40 (109) = happyShift action_35
action_40 (113) = happyShift action_36
action_40 (114) = happyShift action_37
action_40 (115) = happyShift action_38
action_40 (116) = happyShift action_25
action_40 (117) = happyShift action_26
action_40 (119) = happyShift action_39
action_40 (125) = happyShift action_40
action_40 (132) = happyShift action_41
action_40 (133) = happyShift action_42
action_40 (134) = happyShift action_43
action_40 (135) = happyShift action_44
action_40 (60) = happyGoto action_50
action_40 (62) = happyGoto action_31
action_40 (63) = happyGoto action_32
action_40 (83) = happyGoto action_33
action_40 _ = happyFail

action_41 _ = happyReduce_94

action_42 _ = happyReduce_95

action_43 (88) = happyReduce_93
action_43 (91) = happyReduce_124
action_43 (93) = happyReduce_93
action_43 (94) = happyReduce_93
action_43 (95) = happyReduce_93
action_43 (118) = happyReduce_93
action_43 (119) = happyReduce_93
action_43 (120) = happyReduce_93
action_43 (121) = happyReduce_93
action_43 (122) = happyReduce_93
action_43 (123) = happyReduce_93
action_43 (124) = happyReduce_93
action_43 (126) = happyReduce_93
action_43 (127) = happyReduce_93
action_43 (128) = happyReduce_93
action_43 (129) = happyReduce_93
action_43 (130) = happyReduce_93
action_43 (131) = happyReduce_93
action_43 (136) = happyReduce_93
action_43 _ = happyReduce_162

action_44 (116) = happyShift action_10
action_44 (117) = happyShift action_11
action_44 (134) = happyShift action_12
action_44 (135) = happyShift action_13
action_44 (61) = happyGoto action_46
action_44 (78) = happyGoto action_47
action_44 (79) = happyGoto action_48
action_44 (80) = happyGoto action_49
action_44 _ = happyFail

action_45 (137) = happyAccept
action_45 _ = happyFail

action_46 _ = happyReduce_157

action_47 (91) = happyReduce_125
action_47 _ = happyReduce_163

action_48 (129) = happyShift action_134
action_48 _ = happyFail

action_49 (94) = happyShift action_133
action_49 _ = happyReduce_156

action_50 (95) = happyShift action_58
action_50 _ = happyReduce_110

action_51 (95) = happyShift action_58
action_51 _ = happyReduce_117

action_52 (87) = happyShift action_56
action_52 (75) = happyGoto action_132
action_52 _ = happyFail

action_53 _ = happyReduce_124

action_54 (88) = happyShift action_131
action_54 _ = happyFail

action_55 _ = happyReduce_115

action_56 (87) = happyShift action_34
action_56 (88) = happyShift action_130
action_56 (109) = happyShift action_35
action_56 (113) = happyShift action_36
action_56 (114) = happyShift action_37
action_56 (115) = happyShift action_38
action_56 (116) = happyShift action_25
action_56 (117) = happyShift action_26
action_56 (119) = happyShift action_39
action_56 (125) = happyShift action_40
action_56 (132) = happyShift action_41
action_56 (133) = happyShift action_42
action_56 (134) = happyShift action_43
action_56 (135) = happyShift action_44
action_56 (60) = happyGoto action_127
action_56 (62) = happyGoto action_31
action_56 (63) = happyGoto action_32
action_56 (76) = happyGoto action_128
action_56 (77) = happyGoto action_129
action_56 (83) = happyGoto action_33
action_56 _ = happyFail

action_57 (116) = happyShift action_10
action_57 (117) = happyShift action_11
action_57 (134) = happyShift action_12
action_57 (135) = happyShift action_13
action_57 (61) = happyGoto action_46
action_57 (79) = happyGoto action_126
action_57 (80) = happyGoto action_49
action_57 _ = happyFail

action_58 (134) = happyShift action_124
action_58 (135) = happyShift action_125
action_58 (83) = happyGoto action_123
action_58 _ = happyFail

action_59 (87) = happyShift action_34
action_59 (109) = happyShift action_35
action_59 (113) = happyShift action_36
action_59 (114) = happyShift action_37
action_59 (115) = happyShift action_38
action_59 (116) = happyShift action_25
action_59 (117) = happyShift action_26
action_59 (119) = happyShift action_39
action_59 (125) = happyShift action_40
action_59 (132) = happyShift action_41
action_59 (133) = happyShift action_42
action_59 (134) = happyShift action_43
action_59 (135) = happyShift action_44
action_59 (60) = happyGoto action_122
action_59 (62) = happyGoto action_31
action_59 (63) = happyGoto action_32
action_59 (83) = happyGoto action_33
action_59 _ = happyFail

action_60 (87) = happyShift action_34
action_60 (109) = happyShift action_35
action_60 (113) = happyShift action_36
action_60 (114) = happyShift action_37
action_60 (115) = happyShift action_38
action_60 (116) = happyShift action_25
action_60 (117) = happyShift action_26
action_60 (119) = happyShift action_39
action_60 (125) = happyShift action_40
action_60 (132) = happyShift action_41
action_60 (133) = happyShift action_42
action_60 (134) = happyShift action_43
action_60 (135) = happyShift action_44
action_60 (60) = happyGoto action_121
action_60 (62) = happyGoto action_31
action_60 (63) = happyGoto action_32
action_60 (83) = happyGoto action_33
action_60 _ = happyFail

action_61 (87) = happyShift action_34
action_61 (109) = happyShift action_35
action_61 (113) = happyShift action_36
action_61 (114) = happyShift action_37
action_61 (115) = happyShift action_38
action_61 (116) = happyShift action_25
action_61 (117) = happyShift action_26
action_61 (119) = happyShift action_39
action_61 (125) = happyShift action_40
action_61 (132) = happyShift action_41
action_61 (133) = happyShift action_42
action_61 (134) = happyShift action_43
action_61 (135) = happyShift action_44
action_61 (60) = happyGoto action_120
action_61 (62) = happyGoto action_31
action_61 (63) = happyGoto action_32
action_61 (83) = happyGoto action_33
action_61 _ = happyFail

action_62 (87) = happyShift action_34
action_62 (109) = happyShift action_35
action_62 (113) = happyShift action_36
action_62 (114) = happyShift action_37
action_62 (115) = happyShift action_38
action_62 (116) = happyShift action_25
action_62 (117) = happyShift action_26
action_62 (119) = happyShift action_39
action_62 (125) = happyShift action_40
action_62 (132) = happyShift action_41
action_62 (133) = happyShift action_42
action_62 (134) = happyShift action_43
action_62 (135) = happyShift action_44
action_62 (60) = happyGoto action_119
action_62 (62) = happyGoto action_31
action_62 (63) = happyGoto action_32
action_62 (83) = happyGoto action_33
action_62 _ = happyFail

action_63 (87) = happyShift action_34
action_63 (109) = happyShift action_35
action_63 (113) = happyShift action_36
action_63 (114) = happyShift action_37
action_63 (115) = happyShift action_38
action_63 (116) = happyShift action_25
action_63 (117) = happyShift action_26
action_63 (119) = happyShift action_39
action_63 (125) = happyShift action_40
action_63 (132) = happyShift action_41
action_63 (133) = happyShift action_42
action_63 (134) = happyShift action_43
action_63 (135) = happyShift action_44
action_63 (60) = happyGoto action_118
action_63 (62) = happyGoto action_31
action_63 (63) = happyGoto action_32
action_63 (83) = happyGoto action_33
action_63 _ = happyFail

action_64 (87) = happyShift action_34
action_64 (109) = happyShift action_35
action_64 (113) = happyShift action_36
action_64 (114) = happyShift action_37
action_64 (115) = happyShift action_38
action_64 (116) = happyShift action_25
action_64 (117) = happyShift action_26
action_64 (119) = happyShift action_39
action_64 (125) = happyShift action_40
action_64 (132) = happyShift action_41
action_64 (133) = happyShift action_42
action_64 (134) = happyShift action_43
action_64 (135) = happyShift action_44
action_64 (60) = happyGoto action_117
action_64 (62) = happyGoto action_31
action_64 (63) = happyGoto action_32
action_64 (83) = happyGoto action_33
action_64 _ = happyFail

action_65 (87) = happyShift action_34
action_65 (109) = happyShift action_35
action_65 (113) = happyShift action_36
action_65 (114) = happyShift action_37
action_65 (115) = happyShift action_38
action_65 (116) = happyShift action_25
action_65 (117) = happyShift action_26
action_65 (119) = happyShift action_39
action_65 (125) = happyShift action_40
action_65 (132) = happyShift action_41
action_65 (133) = happyShift action_42
action_65 (134) = happyShift action_43
action_65 (135) = happyShift action_44
action_65 (60) = happyGoto action_116
action_65 (62) = happyGoto action_31
action_65 (63) = happyGoto action_32
action_65 (83) = happyGoto action_33
action_65 _ = happyFail

action_66 (87) = happyShift action_34
action_66 (109) = happyShift action_35
action_66 (113) = happyShift action_36
action_66 (114) = happyShift action_37
action_66 (115) = happyShift action_38
action_66 (116) = happyShift action_25
action_66 (117) = happyShift action_26
action_66 (119) = happyShift action_39
action_66 (125) = happyShift action_40
action_66 (132) = happyShift action_41
action_66 (133) = happyShift action_42
action_66 (134) = happyShift action_43
action_66 (135) = happyShift action_44
action_66 (60) = happyGoto action_115
action_66 (62) = happyGoto action_31
action_66 (63) = happyGoto action_32
action_66 (83) = happyGoto action_33
action_66 _ = happyFail

action_67 (87) = happyShift action_34
action_67 (109) = happyShift action_35
action_67 (113) = happyShift action_36
action_67 (114) = happyShift action_37
action_67 (115) = happyShift action_38
action_67 (116) = happyShift action_25
action_67 (117) = happyShift action_26
action_67 (119) = happyShift action_39
action_67 (125) = happyShift action_40
action_67 (132) = happyShift action_41
action_67 (133) = happyShift action_42
action_67 (134) = happyShift action_43
action_67 (135) = happyShift action_44
action_67 (60) = happyGoto action_114
action_67 (62) = happyGoto action_31
action_67 (63) = happyGoto action_32
action_67 (83) = happyGoto action_33
action_67 _ = happyFail

action_68 (87) = happyShift action_34
action_68 (109) = happyShift action_35
action_68 (113) = happyShift action_36
action_68 (114) = happyShift action_37
action_68 (115) = happyShift action_38
action_68 (116) = happyShift action_25
action_68 (117) = happyShift action_26
action_68 (119) = happyShift action_39
action_68 (125) = happyShift action_40
action_68 (132) = happyShift action_41
action_68 (133) = happyShift action_42
action_68 (134) = happyShift action_43
action_68 (135) = happyShift action_44
action_68 (60) = happyGoto action_113
action_68 (62) = happyGoto action_31
action_68 (63) = happyGoto action_32
action_68 (83) = happyGoto action_33
action_68 _ = happyFail

action_69 (87) = happyShift action_34
action_69 (109) = happyShift action_35
action_69 (113) = happyShift action_36
action_69 (114) = happyShift action_37
action_69 (115) = happyShift action_38
action_69 (116) = happyShift action_25
action_69 (117) = happyShift action_26
action_69 (119) = happyShift action_39
action_69 (125) = happyShift action_40
action_69 (132) = happyShift action_41
action_69 (133) = happyShift action_42
action_69 (134) = happyShift action_43
action_69 (135) = happyShift action_44
action_69 (60) = happyGoto action_112
action_69 (62) = happyGoto action_31
action_69 (63) = happyGoto action_32
action_69 (83) = happyGoto action_33
action_69 _ = happyFail

action_70 (87) = happyShift action_34
action_70 (109) = happyShift action_35
action_70 (113) = happyShift action_36
action_70 (114) = happyShift action_37
action_70 (115) = happyShift action_38
action_70 (116) = happyShift action_25
action_70 (117) = happyShift action_26
action_70 (119) = happyShift action_39
action_70 (125) = happyShift action_40
action_70 (132) = happyShift action_41
action_70 (133) = happyShift action_42
action_70 (134) = happyShift action_43
action_70 (135) = happyShift action_44
action_70 (60) = happyGoto action_111
action_70 (62) = happyGoto action_31
action_70 (63) = happyGoto action_32
action_70 (83) = happyGoto action_33
action_70 _ = happyFail

action_71 (87) = happyShift action_34
action_71 (109) = happyShift action_35
action_71 (113) = happyShift action_36
action_71 (114) = happyShift action_37
action_71 (115) = happyShift action_38
action_71 (116) = happyShift action_25
action_71 (117) = happyShift action_26
action_71 (119) = happyShift action_39
action_71 (125) = happyShift action_40
action_71 (132) = happyShift action_41
action_71 (133) = happyShift action_42
action_71 (134) = happyShift action_43
action_71 (135) = happyShift action_44
action_71 (60) = happyGoto action_110
action_71 (62) = happyGoto action_31
action_71 (63) = happyGoto action_32
action_71 (83) = happyGoto action_33
action_71 _ = happyFail

action_72 _ = happyReduce_6

action_73 _ = happyReduce_125

action_74 (92) = happyShift action_109
action_74 _ = happyFail

action_75 (116) = happyShift action_10
action_75 (117) = happyShift action_11
action_75 (134) = happyShift action_12
action_75 (135) = happyShift action_13
action_75 (61) = happyGoto action_108
action_75 _ = happyFail

action_76 _ = happyReduce_136

action_77 (116) = happyShift action_25
action_77 (117) = happyShift action_26
action_77 (134) = happyShift action_53
action_77 (135) = happyShift action_28
action_77 (62) = happyGoto action_31
action_77 (63) = happyGoto action_107
action_77 _ = happyFail

action_78 _ = happyReduce_7

action_79 (92) = happyShift action_106
action_79 _ = happyFail

action_80 (116) = happyShift action_25
action_80 (117) = happyShift action_26
action_80 (134) = happyShift action_53
action_80 (135) = happyShift action_28
action_80 (62) = happyGoto action_31
action_80 (63) = happyGoto action_105
action_80 _ = happyFail

action_81 _ = happyReduce_8

action_82 (116) = happyShift action_10
action_82 (117) = happyShift action_11
action_82 (134) = happyShift action_12
action_82 (135) = happyShift action_13
action_82 (61) = happyGoto action_104
action_82 _ = happyFail

action_83 _ = happyReduce_147

action_84 _ = happyReduce_121

action_85 _ = happyReduce_9

action_86 _ = happyReduce_12

action_87 _ = happyReduce_13

action_88 (116) = happyShift action_25
action_88 (117) = happyShift action_26
action_88 (134) = happyShift action_53
action_88 (135) = happyShift action_28
action_88 (62) = happyGoto action_31
action_88 (63) = happyGoto action_103
action_88 _ = happyFail

action_89 _ = happyReduce_14

action_90 _ = happyReduce_15

action_91 (134) = happyShift action_100
action_91 (135) = happyShift action_101
action_91 (30) = happyGoto action_102
action_91 _ = happyFail

action_92 (134) = happyShift action_100
action_92 (135) = happyShift action_101
action_92 (30) = happyGoto action_99
action_92 _ = happyFail

action_93 _ = happyReduce_17

action_94 (134) = happyShift action_98
action_94 (81) = happyGoto action_96
action_94 (82) = happyGoto action_97
action_94 _ = happyFail

action_95 _ = happyReduce_5

action_96 (129) = happyShift action_149
action_96 _ = happyFail

action_97 (94) = happyShift action_148
action_97 _ = happyReduce_159

action_98 _ = happyReduce_160

action_99 (91) = happyShift action_147
action_99 (22) = happyGoto action_146
action_99 _ = happyReduce_25

action_100 _ = happyReduce_38

action_101 (134) = happyShift action_98
action_101 (81) = happyGoto action_145
action_101 (82) = happyGoto action_97
action_101 _ = happyFail

action_102 (101) = happyShift action_144
action_102 (31) = happyGoto action_143
action_102 _ = happyReduce_40

action_103 (91) = happyShift action_142
action_103 _ = happyFail

action_104 _ = happyReduce_146

action_105 _ = happyReduce_145

action_106 _ = happyReduce_149

action_107 _ = happyReduce_134

action_108 _ = happyReduce_135

action_109 _ = happyReduce_144

action_110 (95) = happyShift action_58
action_110 (118) = happyShift action_59
action_110 (119) = happyShift action_60
action_110 (120) = happyShift action_61
action_110 (121) = happyShift action_62
action_110 (122) = happyShift action_63
action_110 (126) = happyShift action_66
action_110 (127) = happyShift action_67
action_110 (128) = happyShift action_68
action_110 (129) = happyShift action_69
action_110 _ = happyReduce_105

action_111 (95) = happyShift action_58
action_111 (118) = happyShift action_59
action_111 (119) = happyShift action_60
action_111 (120) = happyShift action_61
action_111 (121) = happyShift action_62
action_111 (122) = happyShift action_63
action_111 (126) = happyShift action_66
action_111 (127) = happyShift action_67
action_111 (128) = happyShift action_68
action_111 (129) = happyShift action_69
action_111 _ = happyReduce_104

action_112 (95) = happyShift action_58
action_112 (118) = happyShift action_59
action_112 (119) = happyShift action_60
action_112 (120) = happyShift action_61
action_112 (121) = happyShift action_62
action_112 (122) = happyShift action_63
action_112 _ = happyReduce_109

action_113 (95) = happyShift action_58
action_113 (118) = happyShift action_59
action_113 (119) = happyShift action_60
action_113 (120) = happyShift action_61
action_113 (121) = happyShift action_62
action_113 (122) = happyShift action_63
action_113 _ = happyReduce_108

action_114 (95) = happyShift action_58
action_114 (118) = happyShift action_59
action_114 (119) = happyShift action_60
action_114 (120) = happyShift action_61
action_114 (121) = happyShift action_62
action_114 (122) = happyShift action_63
action_114 _ = happyReduce_107

action_115 (95) = happyShift action_58
action_115 (118) = happyShift action_59
action_115 (119) = happyShift action_60
action_115 (120) = happyShift action_61
action_115 (121) = happyShift action_62
action_115 (122) = happyShift action_63
action_115 _ = happyReduce_106

action_116 (95) = happyShift action_58
action_116 (118) = happyShift action_59
action_116 (119) = happyShift action_60
action_116 (120) = happyShift action_61
action_116 (121) = happyShift action_62
action_116 (122) = happyShift action_63
action_116 (123) = happyShift action_64
action_116 (126) = happyShift action_66
action_116 (127) = happyShift action_67
action_116 (128) = happyShift action_68
action_116 (129) = happyShift action_69
action_116 (130) = happyShift action_70
action_116 (131) = happyShift action_71
action_116 _ = happyReduce_112

action_117 (95) = happyShift action_58
action_117 (118) = happyShift action_59
action_117 (119) = happyShift action_60
action_117 (120) = happyShift action_61
action_117 (121) = happyShift action_62
action_117 (122) = happyShift action_63
action_117 (126) = happyShift action_66
action_117 (127) = happyShift action_67
action_117 (128) = happyShift action_68
action_117 (129) = happyShift action_69
action_117 (130) = happyShift action_70
action_117 (131) = happyShift action_71
action_117 _ = happyReduce_111

action_118 (95) = happyShift action_58
action_118 _ = happyReduce_103

action_119 (95) = happyShift action_58
action_119 _ = happyReduce_102

action_120 (95) = happyShift action_58
action_120 _ = happyReduce_101

action_121 (95) = happyShift action_58
action_121 (120) = happyShift action_61
action_121 (121) = happyShift action_62
action_121 (122) = happyShift action_63
action_121 _ = happyReduce_100

action_122 (95) = happyShift action_58
action_122 (120) = happyShift action_61
action_122 (121) = happyShift action_62
action_122 (122) = happyShift action_63
action_122 _ = happyReduce_99

action_123 (87) = happyShift action_56
action_123 (75) = happyGoto action_141
action_123 _ = happyFail

action_124 (88) = happyReduce_113
action_124 (93) = happyReduce_113
action_124 (94) = happyReduce_113
action_124 (95) = happyReduce_113
action_124 (118) = happyReduce_113
action_124 (119) = happyReduce_113
action_124 (120) = happyReduce_113
action_124 (121) = happyReduce_113
action_124 (122) = happyReduce_113
action_124 (123) = happyReduce_113
action_124 (124) = happyReduce_113
action_124 (126) = happyReduce_113
action_124 (127) = happyReduce_113
action_124 (128) = happyReduce_113
action_124 (129) = happyReduce_113
action_124 (130) = happyReduce_113
action_124 (131) = happyReduce_113
action_124 (136) = happyReduce_113
action_124 _ = happyReduce_162

action_125 (116) = happyShift action_10
action_125 (117) = happyShift action_11
action_125 (134) = happyShift action_12
action_125 (135) = happyShift action_13
action_125 (61) = happyGoto action_46
action_125 (78) = happyGoto action_140
action_125 (79) = happyGoto action_48
action_125 (80) = happyGoto action_49
action_125 _ = happyFail

action_126 (92) = happyShift action_139
action_126 _ = happyFail

action_127 (95) = happyShift action_58
action_127 (118) = happyShift action_59
action_127 (119) = happyShift action_60
action_127 (120) = happyShift action_61
action_127 (121) = happyShift action_62
action_127 (122) = happyShift action_63
action_127 (123) = happyShift action_64
action_127 (124) = happyShift action_65
action_127 (126) = happyShift action_66
action_127 (127) = happyShift action_67
action_127 (128) = happyShift action_68
action_127 (129) = happyShift action_69
action_127 (130) = happyShift action_70
action_127 (131) = happyShift action_71
action_127 _ = happyReduce_153

action_128 (88) = happyShift action_138
action_128 _ = happyFail

action_129 (94) = happyShift action_137
action_129 _ = happyReduce_152

action_130 _ = happyReduce_150

action_131 (87) = happyShift action_34
action_131 (109) = happyShift action_35
action_131 (113) = happyShift action_36
action_131 (114) = happyShift action_37
action_131 (115) = happyShift action_38
action_131 (116) = happyShift action_25
action_131 (117) = happyShift action_26
action_131 (119) = happyShift action_39
action_131 (125) = happyShift action_40
action_131 (132) = happyShift action_41
action_131 (133) = happyShift action_42
action_131 (134) = happyShift action_43
action_131 (135) = happyShift action_44
action_131 (60) = happyGoto action_136
action_131 (62) = happyGoto action_31
action_131 (63) = happyGoto action_32
action_131 (83) = happyGoto action_33
action_131 _ = happyFail

action_132 _ = happyReduce_119

action_133 (116) = happyShift action_10
action_133 (117) = happyShift action_11
action_133 (134) = happyShift action_12
action_133 (135) = happyShift action_13
action_133 (61) = happyGoto action_135
action_133 _ = happyFail

action_134 _ = happyReduce_155

action_135 _ = happyReduce_158

action_136 (95) = happyShift action_58
action_136 _ = happyReduce_118

action_137 (87) = happyShift action_34
action_137 (109) = happyShift action_35
action_137 (113) = happyShift action_36
action_137 (114) = happyShift action_37
action_137 (115) = happyShift action_38
action_137 (116) = happyShift action_25
action_137 (117) = happyShift action_26
action_137 (119) = happyShift action_39
action_137 (125) = happyShift action_40
action_137 (132) = happyShift action_41
action_137 (133) = happyShift action_42
action_137 (134) = happyShift action_43
action_137 (135) = happyShift action_44
action_137 (60) = happyGoto action_163
action_137 (62) = happyGoto action_31
action_137 (63) = happyGoto action_32
action_137 (83) = happyGoto action_33
action_137 _ = happyFail

action_138 _ = happyReduce_151

action_139 (95) = happyShift action_162
action_139 _ = happyFail

action_140 _ = happyReduce_163

action_141 _ = happyReduce_114

action_142 (116) = happyShift action_25
action_142 (117) = happyShift action_26
action_142 (134) = happyShift action_53
action_142 (135) = happyShift action_28
action_142 (62) = happyGoto action_31
action_142 (63) = happyGoto action_159
action_142 (85) = happyGoto action_160
action_142 (86) = happyGoto action_161
action_142 _ = happyFail

action_143 (104) = happyShift action_155
action_143 (64) = happyGoto action_158
action_143 _ = happyReduce_129

action_144 (116) = happyShift action_25
action_144 (117) = happyShift action_26
action_144 (134) = happyShift action_53
action_144 (135) = happyShift action_28
action_144 (62) = happyGoto action_31
action_144 (63) = happyGoto action_157
action_144 _ = happyFail

action_145 (129) = happyShift action_156
action_145 _ = happyFail

action_146 (104) = happyShift action_155
action_146 (64) = happyGoto action_154
action_146 _ = happyReduce_129

action_147 (134) = happyShift action_153
action_147 (23) = happyGoto action_151
action_147 (24) = happyGoto action_152
action_147 _ = happyFail

action_148 (134) = happyShift action_150
action_148 _ = happyFail

action_149 _ = happyReduce_18

action_150 _ = happyReduce_161

action_151 (104) = happyShift action_175
action_151 (68) = happyGoto action_174
action_151 _ = happyReduce_137

action_152 (94) = happyShift action_173
action_152 _ = happyReduce_27

action_153 _ = happyReduce_28

action_154 (89) = happyShift action_172
action_154 _ = happyFail

action_155 (91) = happyShift action_24
action_155 (116) = happyShift action_25
action_155 (117) = happyShift action_26
action_155 (134) = happyShift action_27
action_155 (135) = happyShift action_28
action_155 (62) = happyGoto action_20
action_155 (65) = happyGoto action_169
action_155 (66) = happyGoto action_170
action_155 (67) = happyGoto action_171
action_155 (72) = happyGoto action_22
action_155 (84) = happyGoto action_23
action_155 _ = happyFail

action_156 _ = happyReduce_39

action_157 _ = happyReduce_41

action_158 (89) = happyShift action_168
action_158 _ = happyFail

action_159 _ = happyReduce_166

action_160 (92) = happyShift action_167
action_160 _ = happyFail

action_161 (94) = happyShift action_166
action_161 _ = happyReduce_165

action_162 (134) = happyShift action_165
action_162 (135) = happyShift action_125
action_162 (83) = happyGoto action_164
action_162 _ = happyFail

action_163 (95) = happyShift action_58
action_163 (118) = happyShift action_59
action_163 (119) = happyShift action_60
action_163 (120) = happyShift action_61
action_163 (121) = happyShift action_62
action_163 (122) = happyShift action_63
action_163 (123) = happyShift action_64
action_163 (124) = happyShift action_65
action_163 (126) = happyShift action_66
action_163 (127) = happyShift action_67
action_163 (128) = happyShift action_68
action_163 (129) = happyShift action_69
action_163 (130) = happyShift action_70
action_163 (131) = happyShift action_71
action_163 _ = happyReduce_154

action_164 (87) = happyShift action_56
action_164 (75) = happyGoto action_189
action_164 _ = happyFail

action_165 _ = happyReduce_162

action_166 (116) = happyShift action_25
action_166 (117) = happyShift action_26
action_166 (134) = happyShift action_53
action_166 (135) = happyShift action_28
action_166 (62) = happyGoto action_31
action_166 (63) = happyGoto action_188
action_166 _ = happyFail

action_167 (104) = happyShift action_155
action_167 (64) = happyGoto action_187
action_167 _ = happyReduce_129

action_168 (42) = happyGoto action_185
action_168 (43) = happyGoto action_186
action_168 _ = happyReduce_56

action_169 _ = happyReduce_130

action_170 (94) = happyShift action_184
action_170 _ = happyReduce_131

action_171 _ = happyReduce_132

action_172 (32) = happyGoto action_182
action_172 (33) = happyGoto action_183
action_172 _ = happyReduce_43

action_173 (134) = happyShift action_181
action_173 _ = happyFail

action_174 (92) = happyShift action_180
action_174 _ = happyFail

action_175 (91) = happyShift action_24
action_175 (116) = happyShift action_25
action_175 (117) = happyShift action_26
action_175 (134) = happyShift action_53
action_175 (135) = happyShift action_28
action_175 (62) = happyGoto action_20
action_175 (69) = happyGoto action_176
action_175 (70) = happyGoto action_177
action_175 (71) = happyGoto action_178
action_175 (72) = happyGoto action_179
action_175 _ = happyFail

action_176 _ = happyReduce_138

action_177 (94) = happyShift action_209
action_177 _ = happyReduce_139

action_178 _ = happyReduce_140

action_179 (102) = happyShift action_208
action_179 _ = happyFail

action_180 _ = happyReduce_26

action_181 _ = happyReduce_29

action_182 (106) = happyReduce_69
action_182 (107) = happyShift action_207
action_182 (116) = happyReduce_69
action_182 (117) = happyReduce_69
action_182 (127) = happyShift action_194
action_182 (134) = happyReduce_69
action_182 (135) = happyReduce_69
action_182 (25) = happyGoto action_199
action_182 (26) = happyGoto action_200
action_182 (27) = happyGoto action_201
action_182 (28) = happyGoto action_202
action_182 (35) = happyGoto action_203
action_182 (38) = happyGoto action_204
action_182 (39) = happyGoto action_205
action_182 (51) = happyGoto action_206
action_182 _ = happyReduce_30

action_183 (105) = happyShift action_198
action_183 (37) = happyGoto action_197
action_183 _ = happyReduce_42

action_184 (91) = happyShift action_24
action_184 (116) = happyShift action_25
action_184 (117) = happyShift action_26
action_184 (134) = happyShift action_27
action_184 (135) = happyShift action_28
action_184 (62) = happyGoto action_20
action_184 (67) = happyGoto action_196
action_184 (72) = happyGoto action_22
action_184 (84) = happyGoto action_23
action_184 _ = happyFail

action_185 (90) = happyShift action_195
action_185 _ = happyFail

action_186 (106) = happyReduce_69
action_186 (116) = happyReduce_69
action_186 (117) = happyReduce_69
action_186 (127) = happyShift action_194
action_186 (134) = happyReduce_69
action_186 (135) = happyReduce_69
action_186 (45) = happyGoto action_191
action_186 (50) = happyGoto action_192
action_186 (51) = happyGoto action_193
action_186 _ = happyReduce_55

action_187 (89) = happyShift action_190
action_187 _ = happyFail

action_188 _ = happyReduce_167

action_189 _ = happyReduce_116

action_190 (40) = happyGoto action_225
action_190 (41) = happyGoto action_226
action_190 _ = happyReduce_53

action_191 _ = happyReduce_57

action_192 _ = happyReduce_59

action_193 (106) = happyShift action_216
action_193 (116) = happyShift action_10
action_193 (117) = happyShift action_11
action_193 (134) = happyShift action_12
action_193 (135) = happyShift action_13
action_193 (52) = happyGoto action_224
action_193 (61) = happyGoto action_215
action_193 _ = happyFail

action_194 (134) = happyShift action_98
action_194 (81) = happyGoto action_223
action_194 (82) = happyGoto action_97
action_194 _ = happyFail

action_195 _ = happyReduce_37

action_196 _ = happyReduce_133

action_197 _ = happyReduce_44

action_198 (127) = happyShift action_194
action_198 (39) = happyGoto action_222
action_198 (51) = happyGoto action_206
action_198 _ = happyReduce_69

action_199 (90) = happyShift action_221
action_199 _ = happyFail

action_200 _ = happyReduce_32

action_201 (107) = happyShift action_207
action_201 (28) = happyGoto action_220
action_201 _ = happyReduce_33

action_202 _ = happyReduce_34

action_203 _ = happyReduce_31

action_204 (34) = happyGoto action_218
action_204 (36) = happyGoto action_219
action_204 _ = happyReduce_47

action_205 (93) = happyShift action_217
action_205 _ = happyFail

action_206 (106) = happyShift action_216
action_206 (116) = happyShift action_10
action_206 (117) = happyShift action_11
action_206 (134) = happyShift action_12
action_206 (135) = happyShift action_13
action_206 (52) = happyGoto action_214
action_206 (61) = happyGoto action_215
action_206 _ = happyFail

action_207 (134) = happyShift action_213
action_207 (84) = happyGoto action_212
action_207 _ = happyFail

action_208 (116) = happyShift action_25
action_208 (117) = happyShift action_26
action_208 (134) = happyShift action_53
action_208 (135) = happyShift action_28
action_208 (62) = happyGoto action_31
action_208 (63) = happyGoto action_211
action_208 _ = happyFail

action_209 (91) = happyShift action_24
action_209 (116) = happyShift action_25
action_209 (117) = happyShift action_26
action_209 (134) = happyShift action_53
action_209 (135) = happyShift action_28
action_209 (62) = happyGoto action_20
action_209 (71) = happyGoto action_210
action_209 (72) = happyGoto action_179
action_209 _ = happyFail

action_210 _ = happyReduce_141

action_211 _ = happyReduce_142

action_212 (89) = happyShift action_242
action_212 _ = happyFail

action_213 _ = happyReduce_164

action_214 (134) = happyShift action_241
action_214 _ = happyFail

action_215 _ = happyReduce_72

action_216 _ = happyReduce_71

action_217 _ = happyReduce_50

action_218 _ = happyReduce_46

action_219 (106) = happyReduce_69
action_219 (116) = happyReduce_69
action_219 (117) = happyReduce_69
action_219 (127) = happyShift action_194
action_219 (134) = happyReduce_69
action_219 (135) = happyReduce_69
action_219 (38) = happyGoto action_240
action_219 (39) = happyGoto action_205
action_219 (51) = happyGoto action_206
action_219 _ = happyReduce_45

action_220 _ = happyReduce_35

action_221 _ = happyReduce_24

action_222 (93) = happyShift action_239
action_222 _ = happyFail

action_223 (129) = happyShift action_238
action_223 _ = happyFail

action_224 (87) = happyShift action_236
action_224 (134) = happyShift action_237
action_224 (53) = happyGoto action_235
action_224 _ = happyFail

action_225 (106) = happyReduce_69
action_225 (116) = happyReduce_69
action_225 (117) = happyReduce_69
action_225 (127) = happyShift action_194
action_225 (134) = happyReduce_69
action_225 (135) = happyReduce_69
action_225 (18) = happyGoto action_229
action_225 (19) = happyGoto action_230
action_225 (48) = happyGoto action_231
action_225 (49) = happyGoto action_232
action_225 (50) = happyGoto action_233
action_225 (51) = happyGoto action_234
action_225 _ = happyReduce_21

action_226 (105) = happyShift action_228
action_226 (44) = happyGoto action_227
action_226 _ = happyReduce_52

action_227 _ = happyReduce_54

action_228 (127) = happyShift action_194
action_228 (50) = happyGoto action_256
action_228 (51) = happyGoto action_234
action_228 _ = happyReduce_69

action_229 (90) = happyShift action_255
action_229 _ = happyFail

action_230 (107) = happyShift action_254
action_230 (20) = happyGoto action_253
action_230 _ = happyReduce_19

action_231 _ = happyReduce_20

action_232 (106) = happyReduce_69
action_232 (116) = happyReduce_69
action_232 (117) = happyReduce_69
action_232 (127) = happyShift action_194
action_232 (134) = happyReduce_69
action_232 (135) = happyReduce_69
action_232 (50) = happyGoto action_252
action_232 (51) = happyGoto action_234
action_232 _ = happyReduce_65

action_233 _ = happyReduce_66

action_234 (106) = happyShift action_216
action_234 (116) = happyShift action_10
action_234 (117) = happyShift action_11
action_234 (134) = happyShift action_12
action_234 (135) = happyShift action_13
action_234 (52) = happyGoto action_251
action_234 (61) = happyGoto action_215
action_234 _ = happyFail

action_235 (89) = happyShift action_250
action_235 _ = happyFail

action_236 (116) = happyShift action_10
action_236 (117) = happyShift action_11
action_236 (134) = happyShift action_12
action_236 (135) = happyShift action_13
action_236 (54) = happyGoto action_247
action_236 (55) = happyGoto action_248
action_236 (61) = happyGoto action_249
action_236 _ = happyReduce_74

action_237 (87) = happyShift action_236
action_237 (93) = happyShift action_246
action_237 (53) = happyGoto action_245
action_237 _ = happyFail

action_238 _ = happyReduce_70

action_239 _ = happyReduce_49

action_240 _ = happyReduce_48

action_241 (87) = happyShift action_236
action_241 (53) = happyGoto action_244
action_241 _ = happyFail

action_242 (34) = happyGoto action_243
action_242 (36) = happyGoto action_219
action_242 _ = happyReduce_47

action_243 (90) = happyShift action_266
action_243 _ = happyFail

action_244 (104) = happyShift action_155
action_244 (64) = happyGoto action_265
action_244 _ = happyReduce_129

action_245 (104) = happyShift action_155
action_245 (64) = happyGoto action_264
action_245 _ = happyReduce_129

action_246 _ = happyReduce_61

action_247 (88) = happyShift action_263
action_247 _ = happyFail

action_248 (94) = happyShift action_262
action_248 _ = happyReduce_75

action_249 (134) = happyShift action_261
action_249 _ = happyFail

action_250 (58) = happyGoto action_259
action_250 (59) = happyGoto action_260
action_250 _ = happyReduce_91

action_251 (134) = happyShift action_258
action_251 _ = happyFail

action_252 _ = happyReduce_67

action_253 _ = happyReduce_22

action_254 (89) = happyShift action_257
action_254 _ = happyFail

action_255 _ = happyReduce_16

action_256 _ = happyReduce_58

action_257 (46) = happyGoto action_281
action_257 (47) = happyGoto action_282
action_257 _ = happyReduce_63

action_258 (87) = happyShift action_236
action_258 (53) = happyGoto action_245
action_258 _ = happyFail

action_259 (90) = happyShift action_280
action_259 _ = happyFail

action_260 (87) = happyShift action_34
action_260 (93) = happyShift action_272
action_260 (108) = happyShift action_273
action_260 (109) = happyShift action_35
action_260 (110) = happyShift action_274
action_260 (112) = happyShift action_275
action_260 (113) = happyShift action_36
action_260 (114) = happyShift action_37
action_260 (115) = happyShift action_38
action_260 (116) = happyShift action_276
action_260 (117) = happyShift action_277
action_260 (119) = happyShift action_39
action_260 (125) = happyShift action_40
action_260 (132) = happyShift action_41
action_260 (133) = happyShift action_42
action_260 (134) = happyShift action_278
action_260 (135) = happyShift action_279
action_260 (56) = happyGoto action_269
action_260 (60) = happyGoto action_270
action_260 (61) = happyGoto action_271
action_260 (62) = happyGoto action_31
action_260 (63) = happyGoto action_32
action_260 (83) = happyGoto action_33
action_260 _ = happyReduce_90

action_261 _ = happyReduce_76

action_262 (116) = happyShift action_10
action_262 (117) = happyShift action_11
action_262 (134) = happyShift action_12
action_262 (135) = happyShift action_13
action_262 (61) = happyGoto action_268
action_262 _ = happyFail

action_263 _ = happyReduce_73

action_264 (89) = happyShift action_267
action_264 _ = happyFail

action_265 _ = happyReduce_51

action_266 _ = happyReduce_36

action_267 (58) = happyGoto action_295
action_267 (59) = happyGoto action_260
action_267 _ = happyReduce_91

action_268 (134) = happyShift action_294
action_268 _ = happyFail

action_269 _ = happyReduce_92

action_270 (93) = happyShift action_292
action_270 (95) = happyShift action_293
action_270 (118) = happyShift action_59
action_270 (119) = happyShift action_60
action_270 (120) = happyShift action_61
action_270 (121) = happyShift action_62
action_270 (122) = happyShift action_63
action_270 (123) = happyShift action_64
action_270 (124) = happyShift action_65
action_270 (126) = happyShift action_66
action_270 (127) = happyShift action_67
action_270 (128) = happyShift action_68
action_270 (129) = happyShift action_69
action_270 (130) = happyShift action_70
action_270 (131) = happyShift action_71
action_270 _ = happyFail

action_271 (134) = happyShift action_291
action_271 _ = happyFail

action_272 _ = happyReduce_78

action_273 (87) = happyShift action_34
action_273 (93) = happyShift action_290
action_273 (109) = happyShift action_35
action_273 (113) = happyShift action_36
action_273 (114) = happyShift action_37
action_273 (115) = happyShift action_38
action_273 (116) = happyShift action_25
action_273 (117) = happyShift action_26
action_273 (119) = happyShift action_39
action_273 (125) = happyShift action_40
action_273 (132) = happyShift action_41
action_273 (133) = happyShift action_42
action_273 (134) = happyShift action_43
action_273 (135) = happyShift action_44
action_273 (60) = happyGoto action_289
action_273 (62) = happyGoto action_31
action_273 (63) = happyGoto action_32
action_273 (83) = happyGoto action_33
action_273 _ = happyFail

action_274 (87) = happyShift action_288
action_274 _ = happyFail

action_275 (87) = happyShift action_287
action_275 _ = happyFail

action_276 (134) = happyReduce_122
action_276 _ = happyReduce_126

action_277 (134) = happyReduce_123
action_277 _ = happyReduce_127

action_278 (91) = happyReduce_124
action_278 (93) = happyReduce_93
action_278 (95) = happyReduce_93
action_278 (96) = happyShift action_286
action_278 (118) = happyReduce_93
action_278 (119) = happyReduce_93
action_278 (120) = happyReduce_93
action_278 (121) = happyReduce_93
action_278 (122) = happyReduce_93
action_278 (123) = happyReduce_93
action_278 (124) = happyReduce_93
action_278 (126) = happyReduce_93
action_278 (127) = happyReduce_93
action_278 (128) = happyReduce_93
action_278 (129) = happyReduce_93
action_278 (130) = happyReduce_93
action_278 (131) = happyReduce_93
action_278 (134) = happyReduce_120
action_278 _ = happyReduce_162

action_279 (116) = happyShift action_10
action_279 (117) = happyShift action_11
action_279 (134) = happyShift action_12
action_279 (135) = happyShift action_13
action_279 (61) = happyGoto action_46
action_279 (78) = happyGoto action_285
action_279 (79) = happyGoto action_48
action_279 (80) = happyGoto action_49
action_279 _ = happyFail

action_280 _ = happyReduce_60

action_281 (90) = happyShift action_284
action_281 _ = happyFail

action_282 (106) = happyReduce_69
action_282 (116) = happyReduce_69
action_282 (117) = happyReduce_69
action_282 (127) = happyShift action_194
action_282 (134) = happyReduce_69
action_282 (135) = happyReduce_69
action_282 (50) = happyGoto action_283
action_282 (51) = happyGoto action_234
action_282 _ = happyReduce_62

action_283 _ = happyReduce_64

action_284 _ = happyReduce_23

action_285 (91) = happyReduce_125
action_285 (134) = happyReduce_121
action_285 _ = happyReduce_163

action_286 (87) = happyShift action_34
action_286 (109) = happyShift action_35
action_286 (113) = happyShift action_36
action_286 (114) = happyShift action_37
action_286 (115) = happyShift action_38
action_286 (116) = happyShift action_25
action_286 (117) = happyShift action_26
action_286 (119) = happyShift action_39
action_286 (125) = happyShift action_40
action_286 (132) = happyShift action_41
action_286 (133) = happyShift action_42
action_286 (134) = happyShift action_43
action_286 (135) = happyShift action_44
action_286 (60) = happyGoto action_302
action_286 (62) = happyGoto action_31
action_286 (63) = happyGoto action_32
action_286 (83) = happyGoto action_33
action_286 _ = happyFail

action_287 (87) = happyShift action_34
action_287 (109) = happyShift action_35
action_287 (113) = happyShift action_36
action_287 (114) = happyShift action_37
action_287 (115) = happyShift action_38
action_287 (116) = happyShift action_25
action_287 (117) = happyShift action_26
action_287 (119) = happyShift action_39
action_287 (125) = happyShift action_40
action_287 (132) = happyShift action_41
action_287 (133) = happyShift action_42
action_287 (134) = happyShift action_43
action_287 (135) = happyShift action_44
action_287 (60) = happyGoto action_301
action_287 (62) = happyGoto action_31
action_287 (63) = happyGoto action_32
action_287 (83) = happyGoto action_33
action_287 _ = happyFail

action_288 (87) = happyShift action_34
action_288 (109) = happyShift action_35
action_288 (113) = happyShift action_36
action_288 (114) = happyShift action_37
action_288 (115) = happyShift action_38
action_288 (116) = happyShift action_25
action_288 (117) = happyShift action_26
action_288 (119) = happyShift action_39
action_288 (125) = happyShift action_40
action_288 (132) = happyShift action_41
action_288 (133) = happyShift action_42
action_288 (134) = happyShift action_43
action_288 (135) = happyShift action_44
action_288 (60) = happyGoto action_300
action_288 (62) = happyGoto action_31
action_288 (63) = happyGoto action_32
action_288 (83) = happyGoto action_33
action_288 _ = happyFail

action_289 (93) = happyShift action_299
action_289 (95) = happyShift action_58
action_289 (118) = happyShift action_59
action_289 (119) = happyShift action_60
action_289 (120) = happyShift action_61
action_289 (121) = happyShift action_62
action_289 (122) = happyShift action_63
action_289 (123) = happyShift action_64
action_289 (124) = happyShift action_65
action_289 (126) = happyShift action_66
action_289 (127) = happyShift action_67
action_289 (128) = happyShift action_68
action_289 (129) = happyShift action_69
action_289 (130) = happyShift action_70
action_289 (131) = happyShift action_71
action_289 _ = happyFail

action_290 _ = happyReduce_87

action_291 (96) = happyShift action_298
action_291 _ = happyFail

action_292 _ = happyReduce_79

action_293 (134) = happyShift action_297
action_293 (135) = happyShift action_125
action_293 (83) = happyGoto action_123
action_293 _ = happyFail

action_294 _ = happyReduce_77

action_295 (90) = happyShift action_296
action_295 _ = happyFail

action_296 _ = happyReduce_68

action_297 (93) = happyReduce_113
action_297 (95) = happyReduce_113
action_297 (96) = happyShift action_307
action_297 (118) = happyReduce_113
action_297 (119) = happyReduce_113
action_297 (120) = happyReduce_113
action_297 (121) = happyReduce_113
action_297 (122) = happyReduce_113
action_297 (123) = happyReduce_113
action_297 (124) = happyReduce_113
action_297 (126) = happyReduce_113
action_297 (127) = happyReduce_113
action_297 (128) = happyReduce_113
action_297 (129) = happyReduce_113
action_297 (130) = happyReduce_113
action_297 (131) = happyReduce_113
action_297 _ = happyReduce_162

action_298 (87) = happyShift action_34
action_298 (109) = happyShift action_35
action_298 (113) = happyShift action_36
action_298 (114) = happyShift action_37
action_298 (115) = happyShift action_38
action_298 (116) = happyShift action_25
action_298 (117) = happyShift action_26
action_298 (119) = happyShift action_39
action_298 (125) = happyShift action_40
action_298 (132) = happyShift action_41
action_298 (133) = happyShift action_42
action_298 (134) = happyShift action_43
action_298 (135) = happyShift action_44
action_298 (60) = happyGoto action_306
action_298 (62) = happyGoto action_31
action_298 (63) = happyGoto action_32
action_298 (83) = happyGoto action_33
action_298 _ = happyFail

action_299 _ = happyReduce_86

action_300 (88) = happyShift action_305
action_300 (95) = happyShift action_58
action_300 (118) = happyShift action_59
action_300 (119) = happyShift action_60
action_300 (120) = happyShift action_61
action_300 (121) = happyShift action_62
action_300 (122) = happyShift action_63
action_300 (123) = happyShift action_64
action_300 (124) = happyShift action_65
action_300 (126) = happyShift action_66
action_300 (127) = happyShift action_67
action_300 (128) = happyShift action_68
action_300 (129) = happyShift action_69
action_300 (130) = happyShift action_70
action_300 (131) = happyShift action_71
action_300 _ = happyFail

action_301 (88) = happyShift action_304
action_301 (95) = happyShift action_58
action_301 (118) = happyShift action_59
action_301 (119) = happyShift action_60
action_301 (120) = happyShift action_61
action_301 (121) = happyShift action_62
action_301 (122) = happyShift action_63
action_301 (123) = happyShift action_64
action_301 (124) = happyShift action_65
action_301 (126) = happyShift action_66
action_301 (127) = happyShift action_67
action_301 (128) = happyShift action_68
action_301 (129) = happyShift action_69
action_301 (130) = happyShift action_70
action_301 (131) = happyShift action_71
action_301 _ = happyFail

action_302 (93) = happyShift action_303
action_302 (95) = happyShift action_58
action_302 (118) = happyShift action_59
action_302 (119) = happyShift action_60
action_302 (120) = happyShift action_61
action_302 (121) = happyShift action_62
action_302 (122) = happyShift action_63
action_302 (123) = happyShift action_64
action_302 (124) = happyShift action_65
action_302 (126) = happyShift action_66
action_302 (127) = happyShift action_67
action_302 (128) = happyShift action_68
action_302 (129) = happyShift action_69
action_302 (130) = happyShift action_70
action_302 (131) = happyShift action_71
action_302 _ = happyFail

action_303 _ = happyReduce_81

action_304 (87) = happyShift action_34
action_304 (89) = happyShift action_312
action_304 (93) = happyShift action_272
action_304 (108) = happyShift action_273
action_304 (109) = happyShift action_35
action_304 (110) = happyShift action_274
action_304 (112) = happyShift action_275
action_304 (113) = happyShift action_36
action_304 (114) = happyShift action_37
action_304 (115) = happyShift action_38
action_304 (116) = happyShift action_276
action_304 (117) = happyShift action_277
action_304 (119) = happyShift action_39
action_304 (125) = happyShift action_40
action_304 (132) = happyShift action_41
action_304 (133) = happyShift action_42
action_304 (134) = happyShift action_278
action_304 (135) = happyShift action_279
action_304 (56) = happyGoto action_310
action_304 (57) = happyGoto action_313
action_304 (60) = happyGoto action_270
action_304 (61) = happyGoto action_271
action_304 (62) = happyGoto action_31
action_304 (63) = happyGoto action_32
action_304 (83) = happyGoto action_33
action_304 _ = happyFail

action_305 (87) = happyShift action_34
action_305 (89) = happyShift action_312
action_305 (93) = happyShift action_272
action_305 (108) = happyShift action_273
action_305 (109) = happyShift action_35
action_305 (110) = happyShift action_274
action_305 (112) = happyShift action_275
action_305 (113) = happyShift action_36
action_305 (114) = happyShift action_37
action_305 (115) = happyShift action_38
action_305 (116) = happyShift action_276
action_305 (117) = happyShift action_277
action_305 (119) = happyShift action_39
action_305 (125) = happyShift action_40
action_305 (132) = happyShift action_41
action_305 (133) = happyShift action_42
action_305 (134) = happyShift action_278
action_305 (135) = happyShift action_279
action_305 (56) = happyGoto action_310
action_305 (57) = happyGoto action_311
action_305 (60) = happyGoto action_270
action_305 (61) = happyGoto action_271
action_305 (62) = happyGoto action_31
action_305 (63) = happyGoto action_32
action_305 (83) = happyGoto action_33
action_305 _ = happyFail

action_306 (93) = happyShift action_309
action_306 (95) = happyShift action_58
action_306 (118) = happyShift action_59
action_306 (119) = happyShift action_60
action_306 (120) = happyShift action_61
action_306 (121) = happyShift action_62
action_306 (122) = happyShift action_63
action_306 (123) = happyShift action_64
action_306 (124) = happyShift action_65
action_306 (126) = happyShift action_66
action_306 (127) = happyShift action_67
action_306 (128) = happyShift action_68
action_306 (129) = happyShift action_69
action_306 (130) = happyShift action_70
action_306 (131) = happyShift action_71
action_306 _ = happyFail

action_307 (87) = happyShift action_34
action_307 (109) = happyShift action_35
action_307 (113) = happyShift action_36
action_307 (114) = happyShift action_37
action_307 (115) = happyShift action_38
action_307 (116) = happyShift action_25
action_307 (117) = happyShift action_26
action_307 (119) = happyShift action_39
action_307 (125) = happyShift action_40
action_307 (132) = happyShift action_41
action_307 (133) = happyShift action_42
action_307 (134) = happyShift action_43
action_307 (135) = happyShift action_44
action_307 (60) = happyGoto action_308
action_307 (62) = happyGoto action_31
action_307 (63) = happyGoto action_32
action_307 (83) = happyGoto action_33
action_307 _ = happyFail

action_308 (93) = happyShift action_316
action_308 (95) = happyShift action_58
action_308 (118) = happyShift action_59
action_308 (119) = happyShift action_60
action_308 (120) = happyShift action_61
action_308 (121) = happyShift action_62
action_308 (122) = happyShift action_63
action_308 (123) = happyShift action_64
action_308 (124) = happyShift action_65
action_308 (126) = happyShift action_66
action_308 (127) = happyShift action_67
action_308 (128) = happyShift action_68
action_308 (129) = happyShift action_69
action_308 (130) = happyShift action_70
action_308 (131) = happyShift action_71
action_308 _ = happyFail

action_309 _ = happyReduce_80

action_310 _ = happyReduce_88

action_311 (111) = happyShift action_315
action_311 _ = happyReduce_83

action_312 (58) = happyGoto action_314
action_312 (59) = happyGoto action_260
action_312 _ = happyReduce_91

action_313 _ = happyReduce_85

action_314 (90) = happyShift action_318
action_314 _ = happyFail

action_315 (87) = happyShift action_34
action_315 (89) = happyShift action_312
action_315 (93) = happyShift action_272
action_315 (108) = happyShift action_273
action_315 (109) = happyShift action_35
action_315 (110) = happyShift action_274
action_315 (112) = happyShift action_275
action_315 (113) = happyShift action_36
action_315 (114) = happyShift action_37
action_315 (115) = happyShift action_38
action_315 (116) = happyShift action_276
action_315 (117) = happyShift action_277
action_315 (119) = happyShift action_39
action_315 (125) = happyShift action_40
action_315 (132) = happyShift action_41
action_315 (133) = happyShift action_42
action_315 (134) = happyShift action_278
action_315 (135) = happyShift action_279
action_315 (56) = happyGoto action_310
action_315 (57) = happyGoto action_317
action_315 (60) = happyGoto action_270
action_315 (61) = happyGoto action_271
action_315 (62) = happyGoto action_31
action_315 (63) = happyGoto action_32
action_315 (83) = happyGoto action_33
action_315 _ = happyFail

action_316 _ = happyReduce_82

action_317 _ = happyReduce_84

action_318 _ = happyReduce_89

happyReduce_5 = happySpecReduce_2  8 happyReduction_5
happyReduction_5 _
	(HappyAbsSyn13  happy_var_1)
	 =  HappyAbsSyn8
		 (happy_var_1
	)
happyReduction_5 _ _  = notHappyAtAll 

happyReduce_6 = happySpecReduce_2  9 happyReduction_6
happyReduction_6 _
	(HappyAbsSyn60  happy_var_1)
	 =  HappyAbsSyn9
		 (happy_var_1
	)
happyReduction_6 _ _  = notHappyAtAll 

happyReduce_7 = happySpecReduce_2  10 happyReduction_7
happyReduction_7 _
	(HappyAbsSyn67  happy_var_1)
	 =  HappyAbsSyn10
		 (happy_var_1
	)
happyReduction_7 _ _  = notHappyAtAll 

happyReduce_8 = happySpecReduce_2  11 happyReduction_8
happyReduction_8 _
	(HappyAbsSyn73  happy_var_1)
	 =  HappyAbsSyn11
		 (happy_var_1
	)
happyReduction_8 _ _  = notHappyAtAll 

happyReduce_9 = happySpecReduce_2  12 happyReduction_9
happyReduction_9 _
	(HappyAbsSyn61  happy_var_1)
	 =  HappyAbsSyn12
		 (happy_var_1
	)
happyReduction_9 _ _  = notHappyAtAll 

happyReduce_10 = happySpecReduce_1  13 happyReduction_10
happyReduction_10 (HappyAbsSyn14  happy_var_1)
	 =  HappyAbsSyn13
		 (Program (reverse happy_var_1)
	)
happyReduction_10 _  = notHappyAtAll 

happyReduce_11 = happySpecReduce_0  14 happyReduction_11
happyReduction_11  =  HappyAbsSyn14
		 ([]
	)

happyReduce_12 = happySpecReduce_2  14 happyReduction_12
happyReduction_12 (HappyAbsSyn15  happy_var_2)
	(HappyAbsSyn14  happy_var_1)
	 =  HappyAbsSyn14
		 (happy_var_2 : happy_var_1
	)
happyReduction_12 _ _  = notHappyAtAll 

happyReduce_13 = happySpecReduce_1  15 happyReduction_13
happyReduction_13 (HappyAbsSyn16  happy_var_1)
	 =  HappyAbsSyn15
		 (ImplDef happy_var_1
	)
happyReduction_13 _  = notHappyAtAll 

happyReduce_14 = happySpecReduce_1  15 happyReduction_14
happyReduction_14 (HappyAbsSyn21  happy_var_1)
	 =  HappyAbsSyn15
		 (IfaceDef happy_var_1
	)
happyReduction_14 _  = notHappyAtAll 

happyReduce_15 = happySpecReduce_1  15 happyReduction_15
happyReduction_15 (HappyAbsSyn29  happy_var_1)
	 =  HappyAbsSyn15
		 (ClassDef happy_var_1
	)
happyReduction_15 _  = notHappyAtAll 

happyReduce_16 = happyMonadReduce 10 16 happyReduction_16
happyReduction_16 (_ `HappyStk`
	(HappyAbsSyn18  happy_var_9) `HappyStk`
	(HappyAbsSyn40  happy_var_8) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn64  happy_var_6) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn85  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn63  happy_var_2) `HappyStk`
	(HappyAbsSyn17  happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( undefineTypeParams "implementation" >>
              freshImplId >>= \id ->
              return (Implementation happy_var_1 (asIfaceType happy_var_2) (map asClassType happy_var_4)
                                     happy_var_6 happy_var_8 happy_var_9 id))
	) (\r -> happyReturn (HappyAbsSyn16 r))

happyReduce_17 = happyMonadReduce 1 17 happyReduction_17
happyReduction_17 ((HappyTerminal happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( debug ("Parsing implementation definition at " 
                             ++ show (posn happy_var_1)) >>
                       defineTypeParams "implementation" [])
	) (\r -> happyReturn (HappyAbsSyn17 r))

happyReduce_18 = happyMonadReduce 3 17 happyReduction_18
happyReduction_18 (_ `HappyStk`
	(HappyAbsSyn81  happy_var_2) `HappyStk`
	(HappyTerminal happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( debug ("Parsing implementation definition at " 
                             ++ show (posn happy_var_1)) >>
                       defineTypeParams "implementation" happy_var_2)
	) (\r -> happyReturn (HappyAbsSyn17 r))

happyReduce_19 = happySpecReduce_1  18 happyReduction_19
happyReduction_19 (HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn18
		 (reverse happy_var_1
	)
happyReduction_19 _  = notHappyAtAll 

happyReduce_20 = happySpecReduce_1  18 happyReduction_20
happyReduction_20 (HappyAbsSyn40  happy_var_1)
	 =  HappyAbsSyn18
		 ([ReceiverDef happy_var_1]
	)
happyReduction_20 _  = notHappyAtAll 

happyReduce_21 = happySpecReduce_0  19 happyReduction_21
happyReduction_21  =  HappyAbsSyn19
		 ([]
	)

happyReduce_22 = happySpecReduce_2  19 happyReduction_22
happyReduction_22 (HappyAbsSyn20  happy_var_2)
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_2 : happy_var_1
	)
happyReduction_22 _ _  = notHappyAtAll 

happyReduce_23 = happyReduce 4 20 happyReduction_23
happyReduction_23 (_ `HappyStk`
	(HappyAbsSyn40  happy_var_3) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn20
		 (ReceiverDef happy_var_3
	) `HappyStk` happyRest

happyReduce_24 = happyMonadReduce 8 21 happyReduction_24
happyReduction_24 (_ `HappyStk`
	(HappyAbsSyn25  happy_var_7) `HappyStk`
	(HappyAbsSyn32  happy_var_6) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn64  happy_var_4) `HappyStk`
	(HappyAbsSyn22  happy_var_3) `HappyStk`
	(HappyAbsSyn30  happy_var_2) `HappyStk`
	_ `HappyStk`
	happyRest) tk
	 = happyThen (( handleInterfaceDef happy_var_2 happy_var_3 happy_var_4 happy_var_6 happy_var_7)
	) (\r -> happyReturn (HappyAbsSyn21 r))

happyReduce_25 = happyMonadReduce 0 22 happyReduction_25
happyReduction_25 (happyRest) tk
	 = happyThen (( defineTypeParams "interface" ["This"] >>=
                                   \tyvars -> return (tyvars, []))
	) (\r -> happyReturn (HappyAbsSyn22 r))

happyReduce_26 = happyReduce 4 22 happyReduction_26
happyReduction_26 (_ `HappyStk`
	(HappyAbsSyn68  happy_var_3) `HappyStk`
	(HappyAbsSyn23  happy_var_2) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn22
		 ((happy_var_2, happy_var_3)
	) `HappyStk` happyRest

happyReduce_27 = happyMonadReduce 1 23 happyReduction_27
happyReduction_27 ((HappyAbsSyn24  happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( defineTypeParams "interface" (reverse happy_var_1))
	) (\r -> happyReturn (HappyAbsSyn23 r))

happyReduce_28 = happySpecReduce_1  24 happyReduction_28
happyReduction_28 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn24
		 ([stringOfVar happy_var_1]
	)
happyReduction_28 _  = notHappyAtAll 

happyReduce_29 = happySpecReduce_3  24 happyReduction_29
happyReduction_29 (HappyTerminal happy_var_3)
	_
	(HappyAbsSyn24  happy_var_1)
	 =  HappyAbsSyn24
		 (stringOfVar happy_var_3 : happy_var_1
	)
happyReduction_29 _ _ _  = notHappyAtAll 

happyReduce_30 = happySpecReduce_0  25 happyReduction_30
happyReduction_30  =  HappyAbsSyn25
		 (Nothing
	)

happyReduce_31 = happyMonadReduce 1 25 happyReduction_31
happyReduction_31 ((HappyAbsSyn32  happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( lookupTHIS >>= 
                                        \x -> return (Just [ReceiverSig x happy_var_1 ]))
	) (\r -> happyReturn (HappyAbsSyn25 r))

happyReduce_32 = happySpecReduce_1  25 happyReduction_32
happyReduction_32 (HappyAbsSyn26  happy_var_1)
	 =  HappyAbsSyn25
		 (Just happy_var_1
	)
happyReduction_32 _  = notHappyAtAll 

happyReduce_33 = happySpecReduce_1  26 happyReduction_33
happyReduction_33 (HappyAbsSyn27  happy_var_1)
	 =  HappyAbsSyn26
		 (reverse happy_var_1
	)
happyReduction_33 _  = notHappyAtAll 

happyReduce_34 = happySpecReduce_1  27 happyReduction_34
happyReduction_34 (HappyAbsSyn28  happy_var_1)
	 =  HappyAbsSyn27
		 ([happy_var_1]
	)
happyReduction_34 _  = notHappyAtAll 

happyReduce_35 = happySpecReduce_2  27 happyReduction_35
happyReduction_35 (HappyAbsSyn28  happy_var_2)
	(HappyAbsSyn27  happy_var_1)
	 =  HappyAbsSyn27
		 (happy_var_2 : happy_var_1
	)
happyReduction_35 _ _  = notHappyAtAll 

happyReduce_36 = happyReduce 5 28 happyReduction_36
happyReduction_36 (_ `HappyStk`
	(HappyAbsSyn32  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn84  happy_var_2) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn28
		 (ReceiverSig happy_var_2 happy_var_4
	) `HappyStk` happyRest

happyReduce_37 = happyMonadReduce 7 29 happyReduction_37
happyReduction_37 (_ `HappyStk`
	(HappyAbsSyn42  happy_var_6) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn64  happy_var_4) `HappyStk`
	(HappyAbsSyn31  happy_var_3) `HappyStk`
	(HappyAbsSyn30  happy_var_2) `HappyStk`
	(HappyTerminal happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( handleClassDef happy_var_1 happy_var_2 happy_var_3 happy_var_4 happy_var_6)
	) (\r -> happyReturn (HappyAbsSyn29 r))

happyReduce_38 = happyMonadReduce 1 30 happyReduction_38
happyReduction_38 ((HappyTerminal happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( let name = stringOfVar happy_var_1 in
                         debug ("Parsing class/interface " ++ show name ++ " at "
                               ++ show (posn happy_var_1)) >>
                         defineCurrentClassName name >>
                         defineTypeParams "class/interface" [] >>
                         return (name, []))
	) (\r -> happyReturn (HappyAbsSyn30 r))

happyReduce_39 = happyMonadReduce 3 30 happyReduction_39
happyReduction_39 (_ `HappyStk`
	(HappyAbsSyn81  happy_var_2) `HappyStk`
	(HappyTerminal happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( let name = stringOfVar happy_var_1 in
                         debug ("Parsing class/interface " ++ show name ++ " at "
                               ++ show (posn happy_var_1)) >>
                         defineCurrentClassName name >>
                         defineTypeParams "class/interface" happy_var_2 >>= 
                         \tyvars -> return (name, tyvars))
	) (\r -> happyReturn (HappyAbsSyn30 r))

happyReduce_40 = happySpecReduce_0  31 happyReduction_40
happyReduction_40  =  HappyAbsSyn31
		 (TyClass "Object" []
	)

happyReduce_41 = happySpecReduce_2  31 happyReduction_41
happyReduction_41 (HappyAbsSyn63  happy_var_2)
	_
	 =  HappyAbsSyn31
		 (asClassType happy_var_2
	)
happyReduction_41 _ _  = notHappyAtAll 

happyReduce_42 = happySpecReduce_1  32 happyReduction_42
happyReduction_42 (HappyAbsSyn33  happy_var_1)
	 =  HappyAbsSyn32
		 (reverse happy_var_1
	)
happyReduction_42 _  = notHappyAtAll 

happyReduce_43 = happySpecReduce_0  33 happyReduction_43
happyReduction_43  =  HappyAbsSyn33
		 ([]
	)

happyReduce_44 = happySpecReduce_2  33 happyReduction_44
happyReduction_44 (HappyAbsSyn37  happy_var_2)
	(HappyAbsSyn33  happy_var_1)
	 =  HappyAbsSyn33
		 (happy_var_2 : happy_var_1
	)
happyReduction_44 _ _  = notHappyAtAll 

happyReduce_45 = happySpecReduce_1  34 happyReduction_45
happyReduction_45 (HappyAbsSyn36  happy_var_1)
	 =  HappyAbsSyn32
		 (reverse happy_var_1
	)
happyReduction_45 _  = notHappyAtAll 

happyReduce_46 = happySpecReduce_2  35 happyReduction_46
happyReduction_46 (HappyAbsSyn32  happy_var_2)
	(HappyAbsSyn37  happy_var_1)
	 =  HappyAbsSyn32
		 (happy_var_1 : happy_var_2
	)
happyReduction_46 _ _  = notHappyAtAll 

happyReduce_47 = happySpecReduce_0  36 happyReduction_47
happyReduction_47  =  HappyAbsSyn36
		 ([]
	)

happyReduce_48 = happySpecReduce_2  36 happyReduction_48
happyReduction_48 (HappyAbsSyn37  happy_var_2)
	(HappyAbsSyn36  happy_var_1)
	 =  HappyAbsSyn36
		 (happy_var_2 : happy_var_1
	)
happyReduction_48 _ _  = notHappyAtAll 

happyReduce_49 = happySpecReduce_3  37 happyReduction_49
happyReduction_49 _
	(HappyAbsSyn37  happy_var_2)
	_
	 =  HappyAbsSyn37
		 (happy_var_2
	)
happyReduction_49 _ _ _  = notHappyAtAll 

happyReduce_50 = happySpecReduce_2  38 happyReduction_50
happyReduction_50 _
	(HappyAbsSyn37  happy_var_1)
	 =  HappyAbsSyn37
		 (happy_var_1
	)
happyReduction_50 _ _  = notHappyAtAll 

happyReduce_51 = happyMonadReduce 5 39 happyReduction_51
happyReduction_51 ((HappyAbsSyn64  happy_var_5) `HappyStk`
	(HappyAbsSyn53  happy_var_4) `HappyStk`
	(HappyTerminal happy_var_3) `HappyStk`
	(HappyAbsSyn52  happy_var_2) `HappyStk`
	(HappyAbsSyn17  happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( undefineTypeParams "method" >> 
            undefineExprParams "method" >> 
            return (MethodSig happy_var_1 happy_var_2 (stringOfVar happy_var_3) (snd happy_var_4) happy_var_5))
	) (\r -> happyReturn (HappyAbsSyn37 r))

happyReduce_52 = happySpecReduce_1  40 happyReduction_52
happyReduction_52 (HappyAbsSyn41  happy_var_1)
	 =  HappyAbsSyn40
		 (reverse happy_var_1
	)
happyReduction_52 _  = notHappyAtAll 

happyReduce_53 = happySpecReduce_0  41 happyReduction_53
happyReduction_53  =  HappyAbsSyn41
		 ([]
	)

happyReduce_54 = happySpecReduce_2  41 happyReduction_54
happyReduction_54 (HappyAbsSyn44  happy_var_2)
	(HappyAbsSyn41  happy_var_1)
	 =  HappyAbsSyn41
		 (happy_var_2 : happy_var_1
	)
happyReduction_54 _ _  = notHappyAtAll 

happyReduce_55 = happySpecReduce_1  42 happyReduction_55
happyReduction_55 (HappyAbsSyn43  happy_var_1)
	 =  HappyAbsSyn42
		 (reverse happy_var_1
	)
happyReduction_55 _  = notHappyAtAll 

happyReduce_56 = happySpecReduce_0  43 happyReduction_56
happyReduction_56  =  HappyAbsSyn43
		 ([]
	)

happyReduce_57 = happySpecReduce_2  43 happyReduction_57
happyReduction_57 (HappyAbsSyn45  happy_var_2)
	(HappyAbsSyn43  happy_var_1)
	 =  HappyAbsSyn43
		 (happy_var_2 : happy_var_1
	)
happyReduction_57 _ _  = notHappyAtAll 

happyReduce_58 = happySpecReduce_2  44 happyReduction_58
happyReduction_58 (HappyAbsSyn44  happy_var_2)
	_
	 =  HappyAbsSyn44
		 (happy_var_2
	)
happyReduction_58 _ _  = notHappyAtAll 

happyReduce_59 = happySpecReduce_1  45 happyReduction_59
happyReduction_59 (HappyAbsSyn44  happy_var_1)
	 =  HappyAbsSyn45
		 (Right (Right happy_var_1)
	)
happyReduction_59 _  = notHappyAtAll 

happyReduce_60 = happyMonadReduce 6 45 happyReduction_60
happyReduction_60 (_ `HappyStk`
	(HappyAbsSyn57  happy_var_5) `HappyStk`
	(HappyTerminal happy_var_4) `HappyStk`
	(HappyAbsSyn53  happy_var_3) `HappyStk`
	(HappyAbsSyn52  happy_var_2) `HappyStk`
	(HappyAbsSyn17  happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( do { undefineTypeParams "method/constructor/field"
               ; undefineExprParams "method/constructor/field"
               ; curName <- getCurrentClassName
               ; case (happy_var_1,happy_var_2) of
                   ([], Just (TyParse (TyClassIface name []))) | name == curName
                       -> return (Right (Left (Constructor (fst happy_var_3) (snd happy_var_3) happy_var_5)))
                   _ -> fatal ("Parse error around " ++ show (posn happy_var_4)) })
	) (\r -> happyReturn (HappyAbsSyn45 r))

happyReduce_61 = happyMonadReduce 4 45 happyReduction_61
happyReduction_61 ((HappyTerminal happy_var_4) `HappyStk`
	(HappyTerminal happy_var_3) `HappyStk`
	(HappyAbsSyn52  happy_var_2) `HappyStk`
	(HappyAbsSyn17  happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( do { undefineTypeParams "method/constructor/field"
               ; case (happy_var_1, happy_var_2) of
                   ([], Just t) -> return (Left (FieldDef t (stringOfVar happy_var_3)))
                   _ -> fatal ("Parse error around " ++ show (posn happy_var_4)) })
	) (\r -> happyReturn (HappyAbsSyn45 r))

happyReduce_62 = happySpecReduce_1  46 happyReduction_62
happyReduction_62 (HappyAbsSyn47  happy_var_1)
	 =  HappyAbsSyn40
		 (reverse happy_var_1
	)
happyReduction_62 _  = notHappyAtAll 

happyReduce_63 = happySpecReduce_0  47 happyReduction_63
happyReduction_63  =  HappyAbsSyn47
		 ([]
	)

happyReduce_64 = happySpecReduce_2  47 happyReduction_64
happyReduction_64 (HappyAbsSyn44  happy_var_2)
	(HappyAbsSyn47  happy_var_1)
	 =  HappyAbsSyn47
		 (happy_var_2 : happy_var_1
	)
happyReduction_64 _ _  = notHappyAtAll 

happyReduce_65 = happySpecReduce_1  48 happyReduction_65
happyReduction_65 (HappyAbsSyn49  happy_var_1)
	 =  HappyAbsSyn40
		 (reverse happy_var_1
	)
happyReduction_65 _  = notHappyAtAll 

happyReduce_66 = happySpecReduce_1  49 happyReduction_66
happyReduction_66 (HappyAbsSyn44  happy_var_1)
	 =  HappyAbsSyn49
		 ([happy_var_1]
	)
happyReduction_66 _  = notHappyAtAll 

happyReduce_67 = happySpecReduce_2  49 happyReduction_67
happyReduction_67 (HappyAbsSyn44  happy_var_2)
	(HappyAbsSyn49  happy_var_1)
	 =  HappyAbsSyn49
		 (happy_var_2 : happy_var_1
	)
happyReduction_67 _ _  = notHappyAtAll 

happyReduce_68 = happyMonadReduce 8 50 happyReduction_68
happyReduction_68 (_ `HappyStk`
	(HappyAbsSyn57  happy_var_7) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn64  happy_var_5) `HappyStk`
	(HappyAbsSyn53  happy_var_4) `HappyStk`
	(HappyTerminal happy_var_3) `HappyStk`
	(HappyAbsSyn52  happy_var_2) `HappyStk`
	(HappyAbsSyn17  happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( undefineTypeParams "method/constructor/field" >> 
             undefineExprParams "method/constructor/field" >> 
             return (MethodDef (MethodSig happy_var_1 happy_var_2 (stringOfVar happy_var_3) 
                                          (snd happy_var_4) happy_var_5) (fst happy_var_4) happy_var_7))
	) (\r -> happyReturn (HappyAbsSyn44 r))

happyReduce_69 = happyMonadReduce 0 51 happyReduction_69
happyReduction_69 (happyRest) tk
	 = happyThen (( defineTypeParams "method/constructor/field" [])
	) (\r -> happyReturn (HappyAbsSyn17 r))

happyReduce_70 = happyMonadReduce 3 51 happyReduction_70
happyReduction_70 (_ `HappyStk`
	(HappyAbsSyn81  happy_var_2) `HappyStk`
	_ `HappyStk`
	happyRest) tk
	 = happyThen (( defineTypeParams "method/constructor/field" happy_var_2)
	) (\r -> happyReturn (HappyAbsSyn17 r))

happyReduce_71 = happySpecReduce_1  52 happyReduction_71
happyReduction_71 _
	 =  HappyAbsSyn52
		 (Nothing
	)

happyReduce_72 = happySpecReduce_1  52 happyReduction_72
happyReduction_72 (HappyAbsSyn61  happy_var_1)
	 =  HappyAbsSyn52
		 (Just happy_var_1
	)
happyReduction_72 _  = notHappyAtAll 

happyReduce_73 = happyMonadReduce 3 53 happyReduction_73
happyReduction_73 (_ `HappyStk`
	(HappyAbsSyn54  happy_var_2) `HappyStk`
	_ `HappyStk`
	happyRest) tk
	 = happyThen (( let l = happy_var_2 in
                 defineExprParams "method" ("this" : map snd l) >>= 
                 \ (this:vars) -> return (this,map MethodArg (zip (map fst l) vars)))
	) (\r -> happyReturn (HappyAbsSyn53 r))

happyReduce_74 = happySpecReduce_0  54 happyReduction_74
happyReduction_74  =  HappyAbsSyn54
		 ([]
	)

happyReduce_75 = happySpecReduce_1  54 happyReduction_75
happyReduction_75 (HappyAbsSyn55  happy_var_1)
	 =  HappyAbsSyn54
		 (reverse happy_var_1
	)
happyReduction_75 _  = notHappyAtAll 

happyReduce_76 = happySpecReduce_2  55 happyReduction_76
happyReduction_76 (HappyTerminal happy_var_2)
	(HappyAbsSyn61  happy_var_1)
	 =  HappyAbsSyn55
		 ([(happy_var_1, stringOfVar happy_var_2)]
	)
happyReduction_76 _ _  = notHappyAtAll 

happyReduce_77 = happyReduce 4 55 happyReduction_77
happyReduction_77 ((HappyTerminal happy_var_4) `HappyStk`
	(HappyAbsSyn61  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn55  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn55
		 ((happy_var_3, stringOfVar happy_var_4) : happy_var_1
	) `HappyStk` happyRest

happyReduce_78 = happySpecReduce_1  56 happyReduction_78
happyReduction_78 _
	 =  HappyAbsSyn56
		 (Skip
	)

happyReduce_79 = happySpecReduce_2  56 happyReduction_79
happyReduction_79 _
	(HappyAbsSyn60  happy_var_1)
	 =  HappyAbsSyn56
		 (StmtExpr happy_var_1
	)
happyReduction_79 _ _  = notHappyAtAll 

happyReduce_80 = happyMonadReduce 5 56 happyReduction_80
happyReduction_80 (_ `HappyStk`
	(HappyAbsSyn60  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyTerminal happy_var_2) `HappyStk`
	(HappyAbsSyn61  happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( handleLocalDef happy_var_1 (stringOfVar happy_var_2) happy_var_4)
	) (\r -> happyReturn (HappyAbsSyn56 r))

happyReduce_81 = happyMonadReduce 4 56 happyReduction_81
happyReduction_81 (_ `HappyStk`
	(HappyAbsSyn60  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( handleAssign (stringOfVar happy_var_1) happy_var_3)
	) (\r -> happyReturn (HappyAbsSyn56 r))

happyReduce_82 = happyMonadReduce 6 56 happyReduction_82
happyReduction_82 (_ `HappyStk`
	(HappyAbsSyn60  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyTerminal happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn60  happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( newRef >>= \r -> return (AssignField happy_var_1 (stringOfVar happy_var_3) happy_var_5 r))
	) (\r -> happyReturn (HappyAbsSyn56 r))

happyReduce_83 = happyReduce 5 56 happyReduction_83
happyReduction_83 ((HappyAbsSyn57  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn60  happy_var_3) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn56
		 (If happy_var_3 happy_var_5
	) `HappyStk` happyRest

happyReduce_84 = happyReduce 7 56 happyReduction_84
happyReduction_84 ((HappyAbsSyn57  happy_var_7) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn57  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn60  happy_var_3) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn56
		 (IfElse happy_var_3 happy_var_5 happy_var_7
	) `HappyStk` happyRest

happyReduce_85 = happyReduce 5 56 happyReduction_85
happyReduction_85 ((HappyAbsSyn57  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn60  happy_var_3) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn56
		 (While happy_var_3 happy_var_5
	) `HappyStk` happyRest

happyReduce_86 = happyMonadReduce 3 56 happyReduction_86
happyReduction_86 (_ `HappyStk`
	(HappyAbsSyn60  happy_var_2) `HappyStk`
	_ `HappyStk`
	happyRest) tk
	 = happyThen (( newRef >>= \r -> return (Return (Just happy_var_2) r))
	) (\r -> happyReturn (HappyAbsSyn56 r))

happyReduce_87 = happyMonadReduce 2 56 happyReduction_87
happyReduction_87 (_ `HappyStk`
	_ `HappyStk`
	happyRest) tk
	 = happyThen (( newRef >>= \r -> return (Return Nothing r))
	) (\r -> happyReturn (HappyAbsSyn56 r))

happyReduce_88 = happySpecReduce_1  57 happyReduction_88
happyReduction_88 (HappyAbsSyn56  happy_var_1)
	 =  HappyAbsSyn57
		 ([happy_var_1]
	)
happyReduction_88 _  = notHappyAtAll 

happyReduce_89 = happySpecReduce_3  57 happyReduction_89
happyReduction_89 _
	(HappyAbsSyn57  happy_var_2)
	_
	 =  HappyAbsSyn57
		 (happy_var_2
	)
happyReduction_89 _ _ _  = notHappyAtAll 

happyReduce_90 = happySpecReduce_1  58 happyReduction_90
happyReduction_90 (HappyAbsSyn59  happy_var_1)
	 =  HappyAbsSyn57
		 (reverse happy_var_1
	)
happyReduction_90 _  = notHappyAtAll 

happyReduce_91 = happySpecReduce_0  59 happyReduction_91
happyReduction_91  =  HappyAbsSyn59
		 ([]
	)

happyReduce_92 = happySpecReduce_2  59 happyReduction_92
happyReduction_92 (HappyAbsSyn56  happy_var_2)
	(HappyAbsSyn59  happy_var_1)
	 =  HappyAbsSyn59
		 (happy_var_2 : happy_var_1
	)
happyReduction_92 _ _  = notHappyAtAll 

happyReduce_93 = happyMonadReduce 1 60 happyReduction_93
happyReduction_93 ((HappyTerminal happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( handleExprVar (stringOfVar happy_var_1))
	) (\r -> happyReturn (HappyAbsSyn60 r))

happyReduce_94 = happySpecReduce_1  60 happyReduction_94
happyReduction_94 (HappyTerminal (T _ (NumT happy_var_1)))
	 =  HappyAbsSyn60
		 (Lit (LitInt happy_var_1)
	)
happyReduction_94 _  = notHappyAtAll 

happyReduce_95 = happySpecReduce_1  60 happyReduction_95
happyReduction_95 (HappyTerminal (T _ (StringT happy_var_1)))
	 =  HappyAbsSyn60
		 (Lit (LitString happy_var_1)
	)
happyReduction_95 _  = notHappyAtAll 

happyReduce_96 = happySpecReduce_1  60 happyReduction_96
happyReduction_96 _
	 =  HappyAbsSyn60
		 (Lit LitNull
	)

happyReduce_97 = happySpecReduce_1  60 happyReduction_97
happyReduction_97 _
	 =  HappyAbsSyn60
		 (Lit (LitBool True)
	)

happyReduce_98 = happySpecReduce_1  60 happyReduction_98
happyReduction_98 _
	 =  HappyAbsSyn60
		 (Lit (LitBool False)
	)

happyReduce_99 = happySpecReduce_3  60 happyReduction_99
happyReduction_99 (HappyAbsSyn60  happy_var_3)
	_
	(HappyAbsSyn60  happy_var_1)
	 =  HappyAbsSyn60
		 (PrimOp Add [happy_var_1,happy_var_3]
	)
happyReduction_99 _ _ _  = notHappyAtAll 

happyReduce_100 = happySpecReduce_3  60 happyReduction_100
happyReduction_100 (HappyAbsSyn60  happy_var_3)
	_
	(HappyAbsSyn60  happy_var_1)
	 =  HappyAbsSyn60
		 (PrimOp Sub [happy_var_1,happy_var_3]
	)
happyReduction_100 _ _ _  = notHappyAtAll 

happyReduce_101 = happySpecReduce_3  60 happyReduction_101
happyReduction_101 (HappyAbsSyn60  happy_var_3)
	_
	(HappyAbsSyn60  happy_var_1)
	 =  HappyAbsSyn60
		 (PrimOp Mult [happy_var_1,happy_var_3]
	)
happyReduction_101 _ _ _  = notHappyAtAll 

happyReduce_102 = happySpecReduce_3  60 happyReduction_102
happyReduction_102 (HappyAbsSyn60  happy_var_3)
	_
	(HappyAbsSyn60  happy_var_1)
	 =  HappyAbsSyn60
		 (PrimOp Div [happy_var_1,happy_var_3]
	)
happyReduction_102 _ _ _  = notHappyAtAll 

happyReduce_103 = happySpecReduce_3  60 happyReduction_103
happyReduction_103 (HappyAbsSyn60  happy_var_3)
	_
	(HappyAbsSyn60  happy_var_1)
	 =  HappyAbsSyn60
		 (PrimOp Mod [happy_var_1,happy_var_3]
	)
happyReduction_103 _ _ _  = notHappyAtAll 

happyReduce_104 = happySpecReduce_3  60 happyReduction_104
happyReduction_104 (HappyAbsSyn60  happy_var_3)
	_
	(HappyAbsSyn60  happy_var_1)
	 =  HappyAbsSyn60
		 (PrimOp Equal [happy_var_1,happy_var_3]
	)
happyReduction_104 _ _ _  = notHappyAtAll 

happyReduce_105 = happySpecReduce_3  60 happyReduction_105
happyReduction_105 (HappyAbsSyn60  happy_var_3)
	_
	(HappyAbsSyn60  happy_var_1)
	 =  HappyAbsSyn60
		 (PrimOp NotEqual [happy_var_1,happy_var_3]
	)
happyReduction_105 _ _ _  = notHappyAtAll 

happyReduce_106 = happySpecReduce_3  60 happyReduction_106
happyReduction_106 (HappyAbsSyn60  happy_var_3)
	_
	(HappyAbsSyn60  happy_var_1)
	 =  HappyAbsSyn60
		 (PrimOp Leq [happy_var_1,happy_var_3]
	)
happyReduction_106 _ _ _  = notHappyAtAll 

happyReduce_107 = happySpecReduce_3  60 happyReduction_107
happyReduction_107 (HappyAbsSyn60  happy_var_3)
	_
	(HappyAbsSyn60  happy_var_1)
	 =  HappyAbsSyn60
		 (PrimOp Lt [happy_var_1,happy_var_3]
	)
happyReduction_107 _ _ _  = notHappyAtAll 

happyReduce_108 = happySpecReduce_3  60 happyReduction_108
happyReduction_108 (HappyAbsSyn60  happy_var_3)
	_
	(HappyAbsSyn60  happy_var_1)
	 =  HappyAbsSyn60
		 (PrimOp Geq [happy_var_1,happy_var_3]
	)
happyReduction_108 _ _ _  = notHappyAtAll 

happyReduce_109 = happySpecReduce_3  60 happyReduction_109
happyReduction_109 (HappyAbsSyn60  happy_var_3)
	_
	(HappyAbsSyn60  happy_var_1)
	 =  HappyAbsSyn60
		 (PrimOp Gt [happy_var_1,happy_var_3]
	)
happyReduction_109 _ _ _  = notHappyAtAll 

happyReduce_110 = happySpecReduce_2  60 happyReduction_110
happyReduction_110 (HappyAbsSyn60  happy_var_2)
	_
	 =  HappyAbsSyn60
		 (PrimOp Not [happy_var_2]
	)
happyReduction_110 _ _  = notHappyAtAll 

happyReduce_111 = happySpecReduce_3  60 happyReduction_111
happyReduction_111 (HappyAbsSyn60  happy_var_3)
	_
	(HappyAbsSyn60  happy_var_1)
	 =  HappyAbsSyn60
		 (PrimOp And [happy_var_1,happy_var_3]
	)
happyReduction_111 _ _ _  = notHappyAtAll 

happyReduce_112 = happySpecReduce_3  60 happyReduction_112
happyReduction_112 (HappyAbsSyn60  happy_var_3)
	_
	(HappyAbsSyn60  happy_var_1)
	 =  HappyAbsSyn60
		 (PrimOp Or [happy_var_1,happy_var_3]
	)
happyReduction_112 _ _ _  = notHappyAtAll 

happyReduce_113 = happyMonadReduce 3 60 happyReduction_113
happyReduction_113 ((HappyTerminal happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn60  happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( newRef >>= \t -> return (FAccess happy_var_1 (stringOfVar happy_var_3) t))
	) (\r -> happyReturn (HappyAbsSyn60 r))

happyReduce_114 = happyMonadReduce 4 60 happyReduction_114
happyReduction_114 ((HappyAbsSyn75  happy_var_4) `HappyStk`
	(HappyAbsSyn83  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn60  happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( newRef >>= \t -> return (MCall happy_var_1 (fst happy_var_3) (snd happy_var_3) happy_var_4 t))
	) (\r -> happyReturn (HappyAbsSyn60 r))

happyReduce_115 = happyMonadReduce 2 60 happyReduction_115
happyReduction_115 ((HappyAbsSyn75  happy_var_2) `HappyStk`
	(HappyAbsSyn83  happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( handleMCall (fst happy_var_1) (snd happy_var_1) happy_var_2)
	) (\r -> happyReturn (HappyAbsSyn60 r))

happyReduce_116 = happyMonadReduce 7 60 happyReduction_116
happyReduction_116 ((HappyAbsSyn75  happy_var_7) `HappyStk`
	(HappyAbsSyn83  happy_var_6) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn79  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn63  happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( newRef >>= \t -> return (SMCall (asIfaceType happy_var_1) happy_var_3 (fst happy_var_6) (snd happy_var_6) happy_var_7 t))
	) (\r -> happyReturn (HappyAbsSyn60 r))

happyReduce_117 = happySpecReduce_2  60 happyReduction_117
happyReduction_117 (HappyAbsSyn60  happy_var_2)
	_
	 =  HappyAbsSyn60
		 (PrimOp UnMinus [happy_var_2]
	)
happyReduction_117 _ _  = notHappyAtAll 

happyReduce_118 = happyReduce 4 60 happyReduction_118
happyReduction_118 ((HappyAbsSyn60  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn63  happy_var_2) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn60
		 (Cast (asClassType happy_var_2) happy_var_4
	) `HappyStk` happyRest

happyReduce_119 = happyMonadReduce 3 60 happyReduction_119
happyReduction_119 ((HappyAbsSyn75  happy_var_3) `HappyStk`
	(HappyAbsSyn63  happy_var_2) `HappyStk`
	_ `HappyStk`
	happyRest) tk
	 = happyThen (( newRef >>= \r -> return (New (asClassType happy_var_2) happy_var_3 r))
	) (\r -> happyReturn (HappyAbsSyn60 r))

happyReduce_120 = happyMonadReduce 1 61 happyReduction_120
happyReduction_120 ((HappyTerminal happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( handleType happy_var_1 [])
	) (\r -> happyReturn (HappyAbsSyn61 r))

happyReduce_121 = happyMonadReduce 2 61 happyReduction_121
happyReduction_121 ((HappyAbsSyn78  happy_var_2) `HappyStk`
	(HappyTerminal happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( handleType happy_var_1 happy_var_2)
	) (\r -> happyReturn (HappyAbsSyn61 r))

happyReduce_122 = happySpecReduce_1  61 happyReduction_122
happyReduction_122 _
	 =  HappyAbsSyn61
		 (TyPrim TyInt
	)

happyReduce_123 = happySpecReduce_1  61 happyReduction_123
happyReduction_123 _
	 =  HappyAbsSyn61
		 (TyPrim TyBool
	)

happyReduce_124 = happyMonadReduce 1 62 happyReduction_124
happyReduction_124 ((HappyTerminal happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( handleType happy_var_1 [] >>=
                                                    \t -> return (posn happy_var_1, t))
	) (\r -> happyReturn (HappyAbsSyn62 r))

happyReduce_125 = happyMonadReduce 2 62 happyReduction_125
happyReduction_125 ((HappyAbsSyn78  happy_var_2) `HappyStk`
	(HappyTerminal happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( handleType happy_var_1 happy_var_2  >>=
                                                    \t -> return (posn happy_var_1, t))
	) (\r -> happyReturn (HappyAbsSyn62 r))

happyReduce_126 = happySpecReduce_1  62 happyReduction_126
happyReduction_126 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn62
		 ((posn happy_var_1, TyPrim TyInt)
	)
happyReduction_126 _  = notHappyAtAll 

happyReduce_127 = happySpecReduce_1  62 happyReduction_127
happyReduction_127 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn62
		 ((posn happy_var_1, TyPrim TyBool)
	)
happyReduction_127 _  = notHappyAtAll 

happyReduce_128 = happySpecReduce_1  63 happyReduction_128
happyReduction_128 (HappyAbsSyn62  happy_var_1)
	 =  HappyAbsSyn63
		 (case happy_var_1 of
                           (_, TyParse t) -> t
                           (p,t) -> fatal ("Parse error: expected class or interface "
                                           ++ " type at " ++ show p ++ 
                                           ", found: " ++ show t)
	)
happyReduction_128 _  = notHappyAtAll 

happyReduce_129 = happySpecReduce_0  64 happyReduction_129
happyReduction_129  =  HappyAbsSyn64
		 ([]
	)

happyReduce_130 = happySpecReduce_2  64 happyReduction_130
happyReduction_130 (HappyAbsSyn65  happy_var_2)
	_
	 =  HappyAbsSyn64
		 (happy_var_2
	)
happyReduction_130 _ _  = notHappyAtAll 

happyReduce_131 = happySpecReduce_1  65 happyReduction_131
happyReduction_131 (HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn65
		 (reverse happy_var_1
	)
happyReduction_131 _  = notHappyAtAll 

happyReduce_132 = happySpecReduce_1  66 happyReduction_132
happyReduction_132 (HappyAbsSyn67  happy_var_1)
	 =  HappyAbsSyn66
		 ([happy_var_1]
	)
happyReduction_132 _  = notHappyAtAll 

happyReduce_133 = happySpecReduce_3  66 happyReduction_133
happyReduction_133 (HappyAbsSyn67  happy_var_3)
	_
	(HappyAbsSyn66  happy_var_1)
	 =  HappyAbsSyn66
		 (happy_var_3 : happy_var_1
	)
happyReduction_133 _ _ _  = notHappyAtAll 

happyReduce_134 = happySpecReduce_3  67 happyReduction_134
happyReduction_134 (HappyAbsSyn63  happy_var_3)
	_
	(HappyAbsSyn72  happy_var_1)
	 =  HappyAbsSyn67
		 (ConR (Impl happy_var_1 (asIfaceType happy_var_3))
	)
happyReduction_134 _ _ _  = notHappyAtAll 

happyReduce_135 = happySpecReduce_3  67 happyReduction_135
happyReduction_135 (HappyAbsSyn61  happy_var_3)
	_
	(HappyAbsSyn84  happy_var_1)
	 =  HappyAbsSyn67
		 (Ext happy_var_1 happy_var_3
	)
happyReduction_135 _ _ _  = notHappyAtAll 

happyReduce_136 = happySpecReduce_2  67 happyReduction_136
happyReduction_136 _
	(HappyAbsSyn84  happy_var_1)
	 =  HappyAbsSyn67
		 (Mono happy_var_1
	)
happyReduction_136 _ _  = notHappyAtAll 

happyReduce_137 = happySpecReduce_0  68 happyReduction_137
happyReduction_137  =  HappyAbsSyn68
		 ([]
	)

happyReduce_138 = happySpecReduce_2  68 happyReduction_138
happyReduction_138 (HappyAbsSyn69  happy_var_2)
	_
	 =  HappyAbsSyn68
		 (happy_var_2
	)
happyReduction_138 _ _  = notHappyAtAll 

happyReduce_139 = happySpecReduce_1  69 happyReduction_139
happyReduction_139 (HappyAbsSyn70  happy_var_1)
	 =  HappyAbsSyn69
		 (reverse happy_var_1
	)
happyReduction_139 _  = notHappyAtAll 

happyReduce_140 = happySpecReduce_1  70 happyReduction_140
happyReduction_140 (HappyAbsSyn71  happy_var_1)
	 =  HappyAbsSyn70
		 ([happy_var_1]
	)
happyReduction_140 _  = notHappyAtAll 

happyReduce_141 = happySpecReduce_3  70 happyReduction_141
happyReduction_141 (HappyAbsSyn71  happy_var_3)
	_
	(HappyAbsSyn70  happy_var_1)
	 =  HappyAbsSyn70
		 (happy_var_3 : happy_var_1
	)
happyReduction_141 _ _ _  = notHappyAtAll 

happyReduce_142 = happySpecReduce_3  71 happyReduction_142
happyReduction_142 (HappyAbsSyn63  happy_var_3)
	_
	(HappyAbsSyn72  happy_var_1)
	 =  HappyAbsSyn71
		 (Impl happy_var_1 (asIfaceType happy_var_3)
	)
happyReduction_142 _ _ _  = notHappyAtAll 

happyReduce_143 = happySpecReduce_1  72 happyReduction_143
happyReduction_143 (HappyAbsSyn62  happy_var_1)
	 =  HappyAbsSyn72
		 ([asTyG (fst happy_var_1) (snd happy_var_1)]
	)
happyReduction_143 _  = notHappyAtAll 

happyReduce_144 = happySpecReduce_3  72 happyReduction_144
happyReduction_144 _
	(HappyAbsSyn79  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn72
		 (map (asTyG (posn happy_var_1)) happy_var_2
	)
happyReduction_144 _ _ _  = notHappyAtAll 

happyReduce_145 = happySpecReduce_3  73 happyReduction_145
happyReduction_145 (HappyAbsSyn63  happy_var_3)
	_
	(HappyAbsSyn74  happy_var_1)
	 =  HappyAbsSyn73
		 (ConGR (ImplG happy_var_1 (asIfaceType happy_var_3))
	)
happyReduction_145 _ _ _  = notHappyAtAll 

happyReduce_146 = happySpecReduce_3  73 happyReduction_146
happyReduction_146 (HappyAbsSyn61  happy_var_3)
	_
	(HappyAbsSyn61  happy_var_1)
	 =  HappyAbsSyn73
		 (ExtG happy_var_1 happy_var_3
	)
happyReduction_146 _ _ _  = notHappyAtAll 

happyReduce_147 = happySpecReduce_2  73 happyReduction_147
happyReduction_147 _
	(HappyAbsSyn61  happy_var_1)
	 =  HappyAbsSyn73
		 (MonoG happy_var_1
	)
happyReduction_147 _ _  = notHappyAtAll 

happyReduce_148 = happySpecReduce_1  74 happyReduction_148
happyReduction_148 (HappyAbsSyn61  happy_var_1)
	 =  HappyAbsSyn74
		 ([happy_var_1]
	)
happyReduction_148 _  = notHappyAtAll 

happyReduce_149 = happySpecReduce_3  74 happyReduction_149
happyReduction_149 _
	(HappyAbsSyn79  happy_var_2)
	_
	 =  HappyAbsSyn74
		 (happy_var_2
	)
happyReduction_149 _ _ _  = notHappyAtAll 

happyReduce_150 = happySpecReduce_2  75 happyReduction_150
happyReduction_150 _
	_
	 =  HappyAbsSyn75
		 ([]
	)

happyReduce_151 = happySpecReduce_3  75 happyReduction_151
happyReduction_151 _
	(HappyAbsSyn76  happy_var_2)
	_
	 =  HappyAbsSyn75
		 (happy_var_2
	)
happyReduction_151 _ _ _  = notHappyAtAll 

happyReduce_152 = happySpecReduce_1  76 happyReduction_152
happyReduction_152 (HappyAbsSyn77  happy_var_1)
	 =  HappyAbsSyn76
		 (reverse happy_var_1
	)
happyReduction_152 _  = notHappyAtAll 

happyReduce_153 = happySpecReduce_1  77 happyReduction_153
happyReduction_153 (HappyAbsSyn60  happy_var_1)
	 =  HappyAbsSyn77
		 ([happy_var_1]
	)
happyReduction_153 _  = notHappyAtAll 

happyReduce_154 = happySpecReduce_3  77 happyReduction_154
happyReduction_154 (HappyAbsSyn60  happy_var_3)
	_
	(HappyAbsSyn77  happy_var_1)
	 =  HappyAbsSyn77
		 (happy_var_3 : happy_var_1
	)
happyReduction_154 _ _ _  = notHappyAtAll 

happyReduce_155 = happySpecReduce_2  78 happyReduction_155
happyReduction_155 _
	(HappyAbsSyn79  happy_var_1)
	 =  HappyAbsSyn78
		 (happy_var_1
	)
happyReduction_155 _ _  = notHappyAtAll 

happyReduce_156 = happySpecReduce_1  79 happyReduction_156
happyReduction_156 (HappyAbsSyn80  happy_var_1)
	 =  HappyAbsSyn79
		 (reverse happy_var_1
	)
happyReduction_156 _  = notHappyAtAll 

happyReduce_157 = happySpecReduce_1  80 happyReduction_157
happyReduction_157 (HappyAbsSyn61  happy_var_1)
	 =  HappyAbsSyn80
		 ([happy_var_1]
	)
happyReduction_157 _  = notHappyAtAll 

happyReduce_158 = happySpecReduce_3  80 happyReduction_158
happyReduction_158 (HappyAbsSyn61  happy_var_3)
	_
	(HappyAbsSyn80  happy_var_1)
	 =  HappyAbsSyn80
		 (happy_var_3 : happy_var_1
	)
happyReduction_158 _ _ _  = notHappyAtAll 

happyReduce_159 = happySpecReduce_1  81 happyReduction_159
happyReduction_159 (HappyAbsSyn82  happy_var_1)
	 =  HappyAbsSyn81
		 (reverse happy_var_1
	)
happyReduction_159 _  = notHappyAtAll 

happyReduce_160 = happySpecReduce_1  82 happyReduction_160
happyReduction_160 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn82
		 ([stringOfVar happy_var_1]
	)
happyReduction_160 _  = notHappyAtAll 

happyReduce_161 = happySpecReduce_3  82 happyReduction_161
happyReduction_161 (HappyTerminal happy_var_3)
	_
	(HappyAbsSyn82  happy_var_1)
	 =  HappyAbsSyn82
		 (stringOfVar happy_var_3 : happy_var_1
	)
happyReduction_161 _ _ _  = notHappyAtAll 

happyReduce_162 = happySpecReduce_1  83 happyReduction_162
happyReduction_162 (HappyTerminal happy_var_1)
	 =  HappyAbsSyn83
		 ((stringOfVar happy_var_1, [])
	)
happyReduction_162 _  = notHappyAtAll 

happyReduce_163 = happySpecReduce_2  83 happyReduction_163
happyReduction_163 (HappyAbsSyn78  happy_var_2)
	(HappyTerminal happy_var_1)
	 =  HappyAbsSyn83
		 ((stringOfVar happy_var_1, happy_var_2)
	)
happyReduction_163 _ _  = notHappyAtAll 

happyReduce_164 = happyMonadReduce 1 84 happyReduction_164
happyReduction_164 ((HappyTerminal happy_var_1) `HappyStk`
	happyRest) tk
	 = happyThen (( handleTypeVar happy_var_1)
	) (\r -> happyReturn (HappyAbsSyn84 r))

happyReduce_165 = happySpecReduce_1  85 happyReduction_165
happyReduction_165 (HappyAbsSyn86  happy_var_1)
	 =  HappyAbsSyn85
		 (reverse happy_var_1
	)
happyReduction_165 _  = notHappyAtAll 

happyReduce_166 = happySpecReduce_1  86 happyReduction_166
happyReduction_166 (HappyAbsSyn63  happy_var_1)
	 =  HappyAbsSyn86
		 ([happy_var_1]
	)
happyReduction_166 _  = notHappyAtAll 

happyReduce_167 = happySpecReduce_3  86 happyReduction_167
happyReduction_167 (HappyAbsSyn63  happy_var_3)
	_
	(HappyAbsSyn86  happy_var_1)
	 =  HappyAbsSyn86
		 (happy_var_3 : happy_var_1
	)
happyReduction_167 _ _ _  = notHappyAtAll 

happyNewToken action sts stk [] =
	action 137 137 notHappyAtAll (HappyState action) sts stk []

happyNewToken action sts stk (tk:tks) =
	let cont i = action i i tk (HappyState action) sts stk tks in
	case tk of {
	T _ (SpecialT '(') -> cont 87;
	T _ (SpecialT ')') -> cont 88;
	T _ (SpecialT '{') -> cont 89;
	T _ (SpecialT '}') -> cont 90;
	T _ (SpecialT '[') -> cont 91;
	T _ (SpecialT ']') -> cont 92;
	T _ (SpecialT ';') -> cont 93;
	T _ (SpecialT ',') -> cont 94;
	T _ (SpecialT '.') -> cont 95;
	T _ (SpecialT '=') -> cont 96;
	T _ (KeywordT "class") -> cont 97;
	T _ (KeywordT "interface") -> cont 98;
	T _ (KeywordT "implementation") -> cont 99;
	T _ (KeywordT "implementation<") -> cont 100;
	T _ (KeywordT "extends") -> cont 101;
	T _ (KeywordT "implements") -> cont 102;
	T _ (KeywordT "mono") -> cont 103;
	T _ (KeywordT "where") -> cont 104;
	T _ (KeywordT "static") -> cont 105;
	T _ (KeywordT "void") -> cont 106;
	T _ (KeywordT "receiver") -> cont 107;
	T _ (KeywordT "return") -> cont 108;
	T _ (KeywordT "new") -> cont 109;
	T _ (KeywordT "if") -> cont 110;
	T _ (KeywordT "else") -> cont 111;
	T _ (KeywordT "while") -> cont 112;
	T _ (KeywordT "true") -> cont 113;
	T _ (KeywordT "false") -> cont 114;
	T _ (KeywordT "null") -> cont 115;
	T _ (KeywordT "int") -> cont 116;
	T _ (KeywordT "bool") -> cont 117;
	T _ (OpT "+") -> cont 118;
	T _ (OpT "-") -> cont 119;
	T _ (OpT "*") -> cont 120;
	T _ (OpT "/") -> cont 121;
	T _ (OpT "%") -> cont 122;
	T _ (OpT "&&") -> cont 123;
	T _ (OpT "||") -> cont 124;
	T _ (OpT "!") -> cont 125;
	T _ (OpT "<=") -> cont 126;
	T _ (OpT "<") -> cont 127;
	T _ (OpT ">=") -> cont 128;
	T _ (OpT ">") -> cont 129;
	T _ (OpT "==") -> cont 130;
	T _ (OpT "!=") -> cont 131;
	T _ (NumT happy_dollar_dollar) -> cont 132;
	T _ (StringT happy_dollar_dollar) -> cont 133;
	T _ (VarT _) -> cont 134;
	T _ (VarTyargT _) -> cont 135;
	EOF -> cont 136;
	_ -> happyError' (tk:tks)
	}

happyError_ tk tks = happyError' (tk:tks)

happyThen :: () => PM a -> (a -> PM b) -> PM b
happyThen = (>>=)
happyReturn :: () => a -> PM a
happyReturn = (return)
happyThen1 m k tks = (>>=) m (\a -> k a tks)
happyReturn1 :: () => a -> b -> PM a
happyReturn1 = \a tks -> (return) a
happyError' :: () => [Token] -> PM a
happyError' = parseError

parseProgramIntern tks = happySomeParser where
  happySomeParser = happyThen (happyParse action_0 tks) (\x -> case x of {HappyAbsSyn8 z -> happyReturn z; _other -> notHappyAtAll })

parseExprIntern tks = happySomeParser where
  happySomeParser = happyThen (happyParse action_1 tks) (\x -> case x of {HappyAbsSyn9 z -> happyReturn z; _other -> notHappyAtAll })

parseConstraintIntern tks = happySomeParser where
  happySomeParser = happyThen (happyParse action_2 tks) (\x -> case x of {HappyAbsSyn10 z -> happyReturn z; _other -> notHappyAtAll })

parseConstraintGIntern tks = happySomeParser where
  happySomeParser = happyThen (happyParse action_3 tks) (\x -> case x of {HappyAbsSyn11 z -> happyReturn z; _other -> notHappyAtAll })

parseTypeIntern tks = happySomeParser where
  happySomeParser = happyThen (happyParse action_4 tks) (\x -> case x of {HappyAbsSyn12 z -> happyReturn z; _other -> notHappyAtAll })

happySeq = happyDontSeq


parseProgram :: [Token] -> IO Program
parseProgram toks = 
    do (Program defs,_) <- runStateT (parseProgramIntern toks) emptyParseState
       Program defs' <- parseBuiltinProgram
       return (fixAST (Program (defs' ++ defs)))

parseBuiltinProgram :: IO Program
parseBuiltinProgram =
    do let toks = scan "<builtins>" builtinProgCode
       res <- runStateT (parseProgramIntern toks) emptyParseState
       return (fixBuiltinProg $ fixAST (fst res))

parseExpr :: [Token] -> [String] -> [String] -> IO Expr
parseExpr toks vars tyvars =
    do let state = mkParseState ("this":vars) tyvars
       res <- runStateT (parseExprIntern toks) state
       return (fst res)

parseType :: [Token] -> [String] -> Program -> IO Type
parseType = genericParse parseTypeIntern

parseConstraint :: [Token] -> [String] -> Program -> IO ConP
parseConstraint = genericParse parseConstraintIntern

parseConstraintG :: [Token] -> [String] -> Program -> IO ConGP
parseConstraintG = genericParse parseConstraintGIntern
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "<built-in>" #-}
{-# LINE 1 "<command-line>" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
-- Id: GenericTemplate.hs,v 1.26 2005/01/14 14:47:22 simonmar Exp 

{-# LINE 28 "templates/GenericTemplate.hs" #-}








{-# LINE 49 "templates/GenericTemplate.hs" #-}

{-# LINE 59 "templates/GenericTemplate.hs" #-}

{-# LINE 68 "templates/GenericTemplate.hs" #-}

infixr 9 `HappyStk`
data HappyStk a = HappyStk a (HappyStk a)

-----------------------------------------------------------------------------
-- starting the parse

happyParse start_state = happyNewToken start_state notHappyAtAll notHappyAtAll

-----------------------------------------------------------------------------
-- Accepting the parse

-- If the current token is (1), it means we've just accepted a partial
-- parse (a %partial parser).  We must ignore the saved token on the top of
-- the stack in this case.
happyAccept (1) tk st sts (_ `HappyStk` ans `HappyStk` _) =
	happyReturn1 ans
happyAccept j tk st sts (HappyStk ans _) = 
	 (happyReturn1 ans)

-----------------------------------------------------------------------------
-- Arrays only: do the next action

{-# LINE 155 "templates/GenericTemplate.hs" #-}

-----------------------------------------------------------------------------
-- HappyState data type (not arrays)



newtype HappyState b c = HappyState
        (Int ->                    -- token number
         Int ->                    -- token number (yes, again)
         b ->                           -- token semantic value
         HappyState b c ->              -- current state
         [HappyState b c] ->            -- state stack
         c)



-----------------------------------------------------------------------------
-- Shifting a token

happyShift new_state (1) tk st sts stk@(x `HappyStk` _) =
     let i = (case x of { HappyErrorToken (i) -> i }) in
--     trace "shifting the error token" $
     new_state i i tk (HappyState (new_state)) ((st):(sts)) (stk)

happyShift new_state i tk st sts stk =
     happyNewToken new_state ((st):(sts)) ((HappyTerminal (tk))`HappyStk`stk)

-- happyReduce is specialised for the common cases.

happySpecReduce_0 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_0 nt fn j tk st@((HappyState (action))) sts stk
     = action nt j tk st ((st):(sts)) (fn `HappyStk` stk)

happySpecReduce_1 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_1 nt fn j tk _ sts@(((st@(HappyState (action))):(_))) (v1`HappyStk`stk')
     = let r = fn v1 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_2 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_2 nt fn j tk _ ((_):(sts@(((st@(HappyState (action))):(_))))) (v1`HappyStk`v2`HappyStk`stk')
     = let r = fn v1 v2 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_3 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_3 nt fn j tk _ ((_):(((_):(sts@(((st@(HappyState (action))):(_))))))) (v1`HappyStk`v2`HappyStk`v3`HappyStk`stk')
     = let r = fn v1 v2 v3 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happyReduce k i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyReduce k nt fn j tk st sts stk
     = case happyDrop (k - ((1) :: Int)) sts of
	 sts1@(((st1@(HappyState (action))):(_))) ->
        	let r = fn stk in  -- it doesn't hurt to always seq here...
       		happyDoSeq r (action nt j tk st1 sts1 r)

happyMonadReduce k nt fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyMonadReduce k nt fn j tk st sts stk =
        happyThen1 (fn stk tk) (\r -> action nt j tk st1 sts1 (r `HappyStk` drop_stk))
       where sts1@(((st1@(HappyState (action))):(_))) = happyDrop k ((st):(sts))
             drop_stk = happyDropStk k stk

happyMonad2Reduce k nt fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyMonad2Reduce k nt fn j tk st sts stk =
       happyThen1 (fn stk tk) (\r -> happyNewToken new_state sts1 (r `HappyStk` drop_stk))
       where sts1@(((st1@(HappyState (action))):(_))) = happyDrop k ((st):(sts))
             drop_stk = happyDropStk k stk





             new_state = action


happyDrop (0) l = l
happyDrop n ((_):(t)) = happyDrop (n - ((1) :: Int)) t

happyDropStk (0) l = l
happyDropStk n (x `HappyStk` xs) = happyDropStk (n - ((1)::Int)) xs

-----------------------------------------------------------------------------
-- Moving to a new state after a reduction

{-# LINE 253 "templates/GenericTemplate.hs" #-}
happyGoto action j tk st = action j j tk (HappyState action)


-----------------------------------------------------------------------------
-- Error recovery ((1) is the error token)

-- parse error if we are in recovery and we fail again
happyFail  (1) tk old_st _ stk =
--	trace "failing" $ 
    	happyError_ tk

{-  We don't need state discarding for our restricted implementation of
    "error".  In fact, it can cause some bogus parses, so I've disabled it
    for now --SDM

-- discard a state
happyFail  (1) tk old_st (((HappyState (action))):(sts)) 
						(saved_tok `HappyStk` _ `HappyStk` stk) =
--	trace ("discarding state, depth " ++ show (length stk))  $
	action (1) (1) tk (HappyState (action)) sts ((saved_tok`HappyStk`stk))
-}

-- Enter error recovery: generate an error token,
--                       save the old token and carry on.
happyFail  i tk (HappyState (action)) sts stk =
--      trace "entering error recovery" $
	action (1) (1) tk (HappyState (action)) sts ( (HappyErrorToken (i)) `HappyStk` stk)

-- Internal happy errors:

notHappyAtAll = error "Internal Happy error\n"

-----------------------------------------------------------------------------
-- Hack to get the typechecker to accept our action functions







-----------------------------------------------------------------------------
-- Seq-ing.  If the --strict flag is given, then Happy emits 
--	happySeq = happyDoSeq
-- otherwise it emits
-- 	happySeq = happyDontSeq

happyDoSeq, happyDontSeq :: a -> b -> b
happyDoSeq   a b = a `seq` b
happyDontSeq a b = b

-----------------------------------------------------------------------------
-- Don't inline any functions from the template.  GHC has a nasty habit
-- of deciding to inline happyGoto everywhere, which increases the size of
-- the generated parser quite a bit.

{-# LINE 317 "templates/GenericTemplate.hs" #-}
{-# NOINLINE happyShift #-}
{-# NOINLINE happySpecReduce_0 #-}
{-# NOINLINE happySpecReduce_1 #-}
{-# NOINLINE happySpecReduce_2 #-}
{-# NOINLINE happySpecReduce_3 #-}
{-# NOINLINE happyReduce #-}
{-# NOINLINE happyMonadReduce #-}
{-# NOINLINE happyGoto #-}
{-# NOINLINE happyFail #-}

-- end of Happy Template.
