module ParserTests where

import Lexer
import Parser
import Pretty

test s l1 l2 = let toks = scan "<string>" s in
               render (pp (parseExpr toks l1 l2))

testExpr1 = test "new C<T1,T2>()" ["x", "y"] ["X"]
testExpr2 = test "new C<T1,T2>(x)" ["x", "y"] ["X"]
testExpr3 = test "new C(x).m<X,U1>(x,y)" ["x", "y"] ["X"]
testExpr4 = test "foo<X>()<1" [] ["X"]