/* Expected output:
4
*/
class BTree {
}

class Leaf extends BTree {
  String info;
  Leaf(String info) {
    this.info = info;
  }
}

class Node extends BTree {
  BTree left;
  BTree right;
  Node(BTree left, BTree right) {
    this.left = left;
    this.right = right;
  }
}

interface Count {
  int count();
}

implementation Count [BTree] {
  int count() {
    return 0; // works also for Leaf
  }
}

implementation Count [Node] {
  int count() {
    return this.left.count() + this.right.count() + 1;
  }
}

class Main {
  void main() {
    BTree t = new Node(new Node(new Node(new Leaf("1"), new Leaf("2")),
                                new Leaf("3")),
                       new Node(new Leaf("4"), new Leaf("5")));
    int i = t.count();
    printInt(i); // should print "4"
  }
}