/* Expected output:
Integer(__i=42)
-1
1
0
0
0
*/
interface GIComparable {
  int compareTo(This that);
}

class MaxTest {
  <X> X max(X x1, X x2) where X implements GIComparable {
    if (x1.compareTo(x2) > 0) return x1;
    else return x2;
  }
}

implementation GIComparable [Integer] {
  int compareTo(Integer that) {
    //    print("compareTo for integer");
    if (this.intValue() < that.intValue()) return -1;
    else if (this.intValue() == that.intValue()) return 0;
    else return 1;
  }
}

implementation GIComparable [Object] {
  int compareTo(Object that) {
    //    print("compareTo for objects");
    return 0;
  }
}

class Main {
  void main() {
    MaxTest t = new MaxTest();
    Integer m = t.max<Integer>(new Integer(1), new Integer(42));
    print(m); // should print 42
    printInt(new Integer(2).compareTo(new Integer(3))); // should print -1
    printInt(new Integer(5).compareTo(new Integer(3))); // should print 1
    printInt(new Integer(2).compareTo(new Integer(2))); // should print 0
    printInt("hallo".compareTo(new Integer(2))); // should print 0
    printInt(new Integer(2).compareTo("hallo")); // should print 0    
  }
}