/* Expected output
QueryResult(id="MySQLConnection: INSERT ... INTO customer")
*/
class QueryResult {
  String id;
  QueryResult(String id) {
    this.id = id;
  }
}

class Customer {
}

interface Connection {
  QueryResult exec(String command);
}

class UseConnection {
  QueryResult newCustomer(Connection con, Customer customer) {
    String command = "INSERT ... INTO customer";
    return con.exec(command);
  }
}

class MySQLConnection {
  QueryResult execCommand(String command) {
    return new QueryResult("MySQLConnection: ".concat(command));
  }
}

implementation Connection [MySQLConnection] {
  QueryResult exec(String command) {
    return this.execCommand(command);
  }
}

class Main {
  void main() {
    MySQLConnection conn = new MySQLConnection();
    Customer someCustomer = new Customer();
    QueryResult res = new UseConnection().newCustomer(conn, someCustomer);
    print(res); // should print ``QueryResult(id="MySQLConnection: INSERT ... INTO customer")''
  }
}

class DirectUse {
  void test() {
    QueryResult res = new MySQLConnection().exec("DELETE ...");
  }
}
