#!/bin/sh

JAVAGI=`dirname $0`/../dist/build/javagi/javagi

for x in `ls *.gi` ; do
    echo -n "Running example $x ..."
    $JAVAGI --quiet $x > /dev/null
    ecode=$?
    if [ $ecode -ne 0 ] ; then
	echo
        echo "Example $x failed with exit code $ecode. Aborting."
        exit 1
    else
	echo " [OK]"
    fi
done
