/* 
Type error: ``MySQLConnection'' is not a subtype of ``Connection''
Typing expression ``(new UseConnection()).newCustomer(x_1, x_2)'' failed
Checking statement ``QueryResult x_3 = (new UseConnection()).newCustomer(x_1, x_2);'' failed
 */

/*
Should fail while typechecking Main::main because MySQLConnection
   is not a subtype of connection.
*/
class QueryResult {
  String id;
  QueryResult(String id) {
    this.id = id;
  }
}

class Customer {
}

interface Connection {
  QueryResult exec(String command);
}

class UseConnection {
  QueryResult newCustomer(Connection con, Customer customer) {
    String command = "INSERT ... INTO customer";
    return con.exec(command);
  }
}

class MySQLConnection {
  QueryResult execCommand(String command) {
    return new QueryResult("MySQLConnection: " + command);
  }
}

/*
implementation Connection [MySQLConnection] {
  QueryResult exec(String command) {
    return this.execCommand(command);
  }
}
*/

class Main {
  void main() {
    MySQLConnection conn = new MySQLConnection();
    Customer someCustomer = new Customer();
    QueryResult res = new UseConnection().newCustomer(conn, someCustomer);
    print(res);
  }
}
