/* Should print
1
1
1
1
1
1
2
2
*/
class C1 {}
class C2 extends C1 {}
class C3 extends C2 {}

class D1 {}
class D2 extends D1 {}
class D3 extends D2 {}

interface I [X,Y] {
    receiver X {
        void foo(X x, Y y1, Y y2);
    }
    receiver Y {}
}
implementation I[D1, C1] {
    receiver {
        void foo(D1 x, C1 c1, C1 c2) {
            printInt(1);
        }
    }
}

implementation I[D2, C2] {
    receiver {
        void foo(D2 x, C2 c1, C2 c2) {
            printInt(2);
        }
    }
}

class Main {
    void main() {
        D1 d1 = new D1();
        D1 d2 = new D2();
        D1 d3 = new D3();
        C1 c1 = new C1();
        C1 c2 = new C2();
        C1 c3 = new C3();

        d1.foo(d1, c1, c1);
        d1.foo(d2, c1, c1);
        d1.foo(d2, c2, c1);
        d1.foo(d2, c2, c2);
        d3.foo(d1, c2, c3);
        d3.foo(d2, c3, c1);

        d2.foo(d3, c2, c3);
        d3.foo(d2, c3, c2);
    }
}
